/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#pragma once

#include <shlobj.h>

#include "BrowserToolbarOptions.h"
#include "../Tools/Ini/IniFileEx.h"
#include "../Tools/File/StdFileOperations.h"
#include "LaunchBarOptions.h"

#define QUICK_WAY_TO_FOLDERS_APPLICATION_CONFIGURATION_FILE _T("QuickWayToFolders.ini")
#define QUICK_WAY_TO_FOLDERS_USER_PATH                      _T("QuickWayToFolders\\")
#define QUICK_WAY_TO_FOLDERS_DEFAULT_LANGUAGE               _T("English")
#define QUICK_WAY_TO_FOLDERS_LANGUAGE_FILES_EXTENSION       _T(".ini")
#define QUICK_WAY_TO_FOLDERS_LANGUAGE_DIRECTORY             _T("Languages\\")
#define QUICK_WAY_TO_FOLDERS_FOLDERS_OPTIONS                _T("FoldersOptions.ini")
#define QUICK_WAY_TO_FOLDERS_PER_USER_OPTIONS               _T("UserOptions.ini")
#define CApplicationOptions_WINDOWS_STARTUP_KEY             _T("Software\\Microsoft\\Windows\\CurrentVersion\\Run")
#define CApplicationOptions_QUICK_WAY_TO_FOLDERS_STARTUP_KEY_NAME _T("QuickWayToFolders")

#define CApplicationOptions_KEY_SINGLE_USER                 _T("SingleUser")
#define CApplicationOptions_KEY_LANGUAGE                    _T("Language")
#define CApplicationOptions_KEY_RUN_AT_STARTUP              _T("bRunAtStartup")
#define CApplicationOptions_KEY_USE_SKIN                    _T("bUseSkin")
#define CApplicationOptions_KEY_SKIN_NAME                   _T("SkinName")
#define CApplicationOptions_KEY_LAUNCH_MODE                 _T("LaunchMode")

class CApplicationOptions
{
private:
    TCHAR ApplicationPath[MAX_PATH];
    TCHAR Language[MAX_PATH];
    BOOL bSingleUser;
    void UpdateRunAtStartupStatus(BOOL bCurrentUser);
    void RemoveFromRunAtStartup(BOOL bCurrentUser);
public:
    CApplicationOptions(void);
    ~CApplicationOptions(void);

    TCHAR PerUserOptionsConfigFilePath[MAX_PATH];
    TCHAR FoldersOptionsConfigFilePath[MAX_PATH];
    TCHAR LanguageConfigFilePath[MAX_PATH];
    BOOL bRunAtStartup;

    TCHAR SkinName[MAX_PATH];
    BOOL bUseSkin;
    CBrowserToolbarOptions BrowserToolBarOptions;

    typedef enum tagLaunchMode
    {
        LaunchMode_NOTIFY_ICON = 0,
        LaunchMode_LAUNCH_BAR,
    };

    tagLaunchMode LaunchMode;
    CLaunchBarOptions LaunchBarOptions;

    virtual BOOL Save(CIniFile* pIniFile);
    virtual BOOL Load(CIniFile* pIniFile);
    void GetLanguage(TCHAR* Language,DWORD LanguageMaxSize);
    void SetLanguage(TCHAR* Language);

    void Clone(IN OUT CApplicationOptions* pApplicationOptions);


    void SetUserMode(BOOL bSingleUser);
    void GetUserMode(BOOL* pbSingleUser);

};
