/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "BrowserToolbarOptions.h"
#include "resource.h"

CBrowserToolbarOptions::CBrowserToolbarOptions()
{
    this->hInstance = ::GetModuleHandle(NULL);// exe hInstance = exe module handle = ::GetModuleHandle(NULL)
    this->bUseSkin = FALSE;
    CStdFileOperations::GetAppDirectory(this->SkinsPath,MAX_PATH);
    _tcscat(this->SkinsPath,CBrowserToolbar_SKIN_DIRECTORY);
    *this->CurrentSkinPath = 0;
    *this->SkinPreview = 0;

    this->SetDefaultConfiguration();

    ICON_INFOS* pIconInfos;
    for (SIZE_T Cnt=0;Cnt<IconsId_ELEMENTS_COUNT;Cnt++)
    {
        pIconInfos = &this->IconInfosArray[Cnt];
        pIconInfos->hIcon =NULL;
        pIconInfos->nIconIndex=0;
        *pIconInfos->IconPath =0;
    }

    this->IconInfosArray[IconsId_Home                ].AlternativeResourceId=IDI_ICON_HOME                    ;
    this->IconInfosArray[IconsId_HomeDown            ].AlternativeResourceId=IDI_ICON_HOME_DOWN               ;
    this->IconInfosArray[IconsId_HomeHot             ].AlternativeResourceId=IDI_ICON_HOME_HOT                ;
    this->IconInfosArray[IconsId_Back                ].AlternativeResourceId=IDI_ICON_PREVIOUS                ;
    this->IconInfosArray[IconsId_BackDisabled        ].AlternativeResourceId=IDI_ICON_PREVIOUS_DISABLED       ;
    this->IconInfosArray[IconsId_BackDown            ].AlternativeResourceId=IDI_ICON_PREVIOUS_DOWN           ;
    this->IconInfosArray[IconsId_BackHot             ].AlternativeResourceId=IDI_ICON_PREVIOUS_HOT            ;
    this->IconInfosArray[IconsId_Forward             ].AlternativeResourceId=IDI_ICON_NEXT                    ;
    this->IconInfosArray[IconsId_ForwardDisabled     ].AlternativeResourceId=IDI_ICON_NEXT_DISABLED           ;
    this->IconInfosArray[IconsId_ForwardDown         ].AlternativeResourceId=IDI_ICON_NEXT_DOWN               ;
    this->IconInfosArray[IconsId_ForwardHot          ].AlternativeResourceId=IDI_ICON_NEXT_HOT                ;
    this->IconInfosArray[IconsId_Up                  ].AlternativeResourceId=IDI_ICON_UP                      ;
    this->IconInfosArray[IconsId_UpDown              ].AlternativeResourceId=IDI_ICON_UP_DOWN                 ;
    this->IconInfosArray[IconsId_UpHot               ].AlternativeResourceId=IDI_ICON_UP_HOT                  ;
    this->IconInfosArray[IconsId_JumpToExplorer      ].AlternativeResourceId=IDI_ICON_JUMP_TO_EXPLORER        ;
    this->IconInfosArray[IconsId_JumpToExplorerDown  ].AlternativeResourceId=IDI_ICON_JUMP_TO_EXPLORER_DOWN   ;
    this->IconInfosArray[IconsId_JumpToExplorerHot   ].AlternativeResourceId=IDI_ICON_JUMP_TO_EXPLORER_HOT    ;
    this->IconInfosArray[IconsId_Move                ].AlternativeResourceId=IDI_ICON_MOVE                    ;
    this->IconInfosArray[IconsId_MoveDown            ].AlternativeResourceId=IDI_ICON_MOVE_DOWN               ;
    this->IconInfosArray[IconsId_MoveHot             ].AlternativeResourceId=IDI_ICON_MOVE_HOT                ;
    this->IconInfosArray[IconsId_Maximize            ].AlternativeResourceId=IDI_ICON_MAXIMIZE                ;
    this->IconInfosArray[IconsId_MaximizeDown        ].AlternativeResourceId=IDI_ICON_MAXIMIZE_DOWN           ;
    this->IconInfosArray[IconsId_MaximizeHot         ].AlternativeResourceId=IDI_ICON_MAXIMIZE_HOT            ;
    this->IconInfosArray[IconsId_Reduce              ].AlternativeResourceId=IDI_ICON_REDUCE                  ;
    this->IconInfosArray[IconsId_ReduceDown          ].AlternativeResourceId=IDI_ICON_REDUCE_DOWN             ;
    this->IconInfosArray[IconsId_ReduceHot           ].AlternativeResourceId=IDI_ICON_REDUCE_HOT              ;
    this->IconInfosArray[IconsId_Close               ].AlternativeResourceId=IDI_ICON_CLOSE                   ;
    this->IconInfosArray[IconsId_CloseDown           ].AlternativeResourceId=IDI_ICON_CLOSE_DOWN              ;
    this->IconInfosArray[IconsId_CloseHot            ].AlternativeResourceId=IDI_ICON_CLOSE_HOT               ;


    this->IconInfosArray[IconsId_Home                ].AssociatedIconsPrefix=_T("Home");
    this->IconInfosArray[IconsId_HomeDown            ].AssociatedIconsPrefix=_T("HomeDown");
    this->IconInfosArray[IconsId_HomeHot             ].AssociatedIconsPrefix=_T("HomeHot");
    this->IconInfosArray[IconsId_Back            ].AssociatedIconsPrefix=_T("Back");
    this->IconInfosArray[IconsId_BackDisabled    ].AssociatedIconsPrefix=_T("BackDisabled");
    this->IconInfosArray[IconsId_BackDown        ].AssociatedIconsPrefix=_T("BackDown");
    this->IconInfosArray[IconsId_BackHot         ].AssociatedIconsPrefix=_T("BackHot");
    this->IconInfosArray[IconsId_Forward                ].AssociatedIconsPrefix=_T("Forward");
    this->IconInfosArray[IconsId_ForwardDisabled        ].AssociatedIconsPrefix=_T("ForwardDisabled");
    this->IconInfosArray[IconsId_ForwardDown            ].AssociatedIconsPrefix=_T("ForwardDown");
    this->IconInfosArray[IconsId_ForwardHot             ].AssociatedIconsPrefix=_T("ForwardHot");
    this->IconInfosArray[IconsId_Up                  ].AssociatedIconsPrefix=_T("Up");
    this->IconInfosArray[IconsId_UpDown              ].AssociatedIconsPrefix=_T("UpDown");
    this->IconInfosArray[IconsId_UpHot               ].AssociatedIconsPrefix=_T("UpHot");
    this->IconInfosArray[IconsId_JumpToExplorer      ].AssociatedIconsPrefix=_T("JumpToExplorer");
    this->IconInfosArray[IconsId_JumpToExplorerDown  ].AssociatedIconsPrefix=_T("JumpToExplorerDown");
    this->IconInfosArray[IconsId_JumpToExplorerHot   ].AssociatedIconsPrefix=_T("JumpToExplorerHot");
    this->IconInfosArray[IconsId_Move                ].AssociatedIconsPrefix=_T("Move");
    this->IconInfosArray[IconsId_MoveDown            ].AssociatedIconsPrefix=_T("MoveDown");
    this->IconInfosArray[IconsId_MoveHot             ].AssociatedIconsPrefix=_T("MoveHot");
    this->IconInfosArray[IconsId_Maximize            ].AssociatedIconsPrefix=_T("Maximize");
    this->IconInfosArray[IconsId_MaximizeDown        ].AssociatedIconsPrefix=_T("MaximizeDown");
    this->IconInfosArray[IconsId_MaximizeHot         ].AssociatedIconsPrefix=_T("MaximizeHot");
    this->IconInfosArray[IconsId_Reduce              ].AssociatedIconsPrefix=_T("Reduce");
    this->IconInfosArray[IconsId_ReduceDown          ].AssociatedIconsPrefix=_T("ReduceDown");
    this->IconInfosArray[IconsId_ReduceHot           ].AssociatedIconsPrefix=_T("ReduceHot");
    this->IconInfosArray[IconsId_Close               ].AssociatedIconsPrefix=_T("Close");
    this->IconInfosArray[IconsId_CloseDown           ].AssociatedIconsPrefix=_T("CloseDown");
    this->IconInfosArray[IconsId_CloseHot            ].AssociatedIconsPrefix=_T("CloseHot");
}

void CBrowserToolbarOptions::SetDefaultConfiguration()
{
    this->TransparentColor = CBrowserToolbar_TRANSPARENT_COLOR;
    this->bUseTransparentColor = TRUE;
    this->BackGroundType = CTransparentToolbar::BACKGROUND_SOLID_BRUSH;
    this->BackGroundColor = CBrowserToolbar_TRANSPARENT_COLOR;
    this->BackGroundColor2 = CBrowserToolbar_TRANSPARENT_COLOR;
    *this->BackGroundImage = 0;
    this->OpacityPercent = CBrowserToolbar_OPACITY;
    this->bMoveButtonEnabled = TRUE;
    this->PositionMode = CTransparentToolbar::BarPositionMode_POPUP; // historicaly only external positioning was supported
}

CBrowserToolbarOptions::~CBrowserToolbarOptions(void)
{
    this->FreeAllIcons();
}

void CBrowserToolbarOptions::FreeAllIcons()
{
    std::vector<HICON>::iterator hIconIterator;
    for (hIconIterator = this->IconToDestroyList.begin(); hIconIterator!=this->IconToDestroyList.end(); hIconIterator++)
    {
        ::DestroyIcon(*hIconIterator);
    }
    this->IconToDestroyList.clear();
}

HICON CBrowserToolbarOptions::GetCurrentSkinIcon(IconsId IconId)
{
    if (IconId<IconsId_ELEMENTS_COUNT)
        return this->IconInfosArray[IconId].hIcon;
    else
        return NULL;
}

HICON CBrowserToolbarOptions::LoadIcon(int AlternativeIconResourceId)
{
    return (HICON)::LoadImage(this->hInstance, MAKEINTRESOURCE(AlternativeIconResourceId),IMAGE_ICON,CBrowserToolbar_ICON_SIZE,CBrowserToolbar_ICON_SIZE,LR_SHARED);
}

HICON CBrowserToolbarOptions::LoadIcon(TCHAR* IconRelativePath,int IconIndex,int AlternativeIconResourceId)
{
    HICON hIconLarge;

    if (this->bUseSkin)
    {
        TCHAR AbsolutePath[MAX_PATH];
        CStdFileOperations::GetAbsolutePath(this->CurrentSkinPath,IconRelativePath,AbsolutePath,_countof(AbsolutePath));
        // extract wanted icon
        if (
                //((int)::ExtractIconEx(AbsolutePath,
                //                        IconIndex, 
                //                        &hIconLarge, 
                //                        NULL, 
                //                        1)
                // )<=0
                ((int)::PrivateExtractIcons(AbsolutePath,IconIndex,CBrowserToolbar_ICON_SIZE,CBrowserToolbar_ICON_SIZE,&hIconLarge,NULL,1,LR_DEFAULTCOLOR))<=0
            )
        {
            hIconLarge = this->LoadIcon(AlternativeIconResourceId);
        }
        else
        {
            this->IconToDestroyList.push_back(hIconLarge);
        }
    }
    else
        hIconLarge = this->LoadIcon(AlternativeIconResourceId);

    return hIconLarge;
}

BOOL CBrowserToolbarOptions::Load(BOOL bUseSkin,TCHAR* SkinName)
{
    TCHAR KeyName[512];
    TCHAR SkinFilePath[MAX_PATH];
    CIniFile* pIniFile=NULL;

    this->bUseSkin=bUseSkin;

    _tcscpy(this->CurrentSkinPath,this->SkinsPath);
    _tcscat(this->CurrentSkinPath,SkinName);
    _tcscat(this->CurrentSkinPath,_T("\\"));

    // free previous allocated icons if any
    this->FreeAllIcons();

    if (this->bUseSkin)
    {
        DWORD dwTmp;
        TCHAR RelativePath[MAX_PATH];

        _tcscpy(SkinFilePath,this->CurrentSkinPath);
        _tcscat(SkinFilePath,CBrowserToolbar_SKIN_CONFIGURATION_FILENAME);
        pIniFile=new CIniFile(SkinFilePath);
        // set ini section name
        pIniFile->SetCurrentSectionName(CBrowserToolbar_SECTION_NAME);

        pIniFile->Get(CBrowserToolbar_KEY_BACKGROUNDTYPE,CTransparentToolbar::BACKGROUND_SOLID_BRUSH,&dwTmp);
        this->BackGroundType = (CTransparentToolbar::tagBackgroundType)dwTmp;
        pIniFile->Get(CBrowserToolbar_KEY_BACKGROUNDCOLOR,CBrowserToolbar_TRANSPARENT_COLOR,&this->BackGroundColor);
        pIniFile->Get(CBrowserToolbar_KEY_BACKGROUNDCOLOR2,CBrowserToolbar_TRANSPARENT_COLOR,&this->BackGroundColor2);
        pIniFile->Get( CBrowserToolbar_KEY_BACKGROUNDIMAGE,_T(""),RelativePath,_countof(RelativePath));
        CStdFileOperations::GetAbsolutePath(this->CurrentSkinPath,RelativePath,this->BackGroundImage,MAX_PATH);
        pIniFile->Get(CBrowserToolbar_KEY_TRANSPARENTCOLOR,CBrowserToolbar_TRANSPARENT_COLOR,&this->TransparentColor);
        pIniFile->Get(CBrowserToolbar_KEY_USETRANSPARENTCOLOR,TRUE,(DWORD*)&this->bUseTransparentColor);
        
        pIniFile->Get(CBrowserToolbar_KEY_OPACITYPERCENT,CBrowserToolbar_OPACITY,&dwTmp);
        this->OpacityPercent = (BYTE)dwTmp; 
        pIniFile->Get(CBrowserToolbar_KEY_MOVE_BUTTON,TRUE,(DWORD*)&this->bMoveButtonEnabled);

        pIniFile->Get(CBrowserToolbar_KEY_POSITION_MODE,(DWORD)CTransparentToolbar::BarPositionMode_POPUP,&dwTmp);
        this->PositionMode = (CTransparentToolbar::tagBarPositionMode)dwTmp;
    }
    else
    {
        this->SetDefaultConfiguration();
    }

    ICON_INFOS* pIconInfos;
    for (SIZE_T Cnt=0;Cnt<IconsId_ELEMENTS_COUNT;Cnt++)
    {     
        pIconInfos = &this->IconInfosArray[Cnt];

        if (this->bUseSkin)
        {
            _tcscpy(KeyName,pIconInfos->AssociatedIconsPrefix);
            _tcscat(KeyName,CBrowserToolbar_KEY_ASSOCIATEDICONPATH);
            pIniFile->Get(KeyName,_T(""),pIconInfos->IconPath,MAX_PATH);

            _tcscpy(KeyName,pIconInfos->AssociatedIconsPrefix);
            _tcscat(KeyName,CBrowserToolbar_KEY_ASSOCIATEDICONINDEX);
            pIniFile->Get(KeyName,0,(DWORD*)&pIconInfos->nIconIndex);

            pIconInfos->hIcon=this->LoadIcon(pIconInfos->IconPath,pIconInfos->nIconIndex,pIconInfos->AlternativeResourceId);
        }
        else
            pIconInfos->hIcon=this->LoadIcon(pIconInfos->AlternativeResourceId);
    }

    if (this->bUseSkin)
    {
        pIniFile->SetCurrentSectionName(CBrowserToolbar_SECTION_NAME_PREVIEW);
        pIniFile->Get(CBrowserToolbar_KEY_PREVIEW_FILE_NAME,_T(""),this->SkinPreview,MAX_PATH);
        delete pIniFile;
    }


#ifdef _DEBUG

// #define GENERATE_NAMES

#ifdef GENERATE_NAMES
    OutputDebugString(_T("\r\nMultiple icones names \r\n\r\n"));
    for (SIZE_T Cnt=0;Cnt<IconsId_ELEMENTS_COUNT;Cnt++)
    {     
        pIconInfos = &this->IconInfosArray[Cnt];

        _tcscpy(KeyName,pIconInfos->AssociatedIconsPrefix);
        _tcscat(KeyName,CBrowserToolbar_KEY_ASSOCIATEDICONPATH);
        OutputDebugString(KeyName);
        OutputDebugString(_T("="));
        OutputDebugString(pIconInfos->AssociatedIconsPrefix);
        OutputDebugString(_T(".ico\r\n"));

        _tcscpy(KeyName,pIconInfos->AssociatedIconsPrefix);
        _tcscat(KeyName,CBrowserToolbar_KEY_ASSOCIATEDICONINDEX);
        OutputDebugString(KeyName);
        OutputDebugString(_T("="));
        OutputDebugString(_T("0\r\n"));
    }

    TCHAR StrCnt[128];
    OutputDebugString(_T("\r\nDll Resource names \r\n\r\n"));
    for (SIZE_T Cnt=0;Cnt<IconsId_ELEMENTS_COUNT;Cnt++)
    {     
        pIconInfos = &this->IconInfosArray[Cnt];

        _tcscpy(KeyName,pIconInfos->AssociatedIconsPrefix);
        _tcscat(KeyName,CBrowserToolbar_KEY_ASSOCIATEDICONPATH);
        OutputDebugString(KeyName);
        OutputDebugString(_T("=Resource.dll\r\n"));

        _tcscpy(KeyName,pIconInfos->AssociatedIconsPrefix);
        _tcscat(KeyName,CBrowserToolbar_KEY_ASSOCIATEDICONINDEX);
        OutputDebugString(KeyName);
        OutputDebugString(_T("="));

        _sntprintf(StrCnt,_countof(StrCnt),_T("%u"),Cnt);
        OutputDebugString(StrCnt);
        OutputDebugString(_T("\r\n"));
    }
#endif
#endif


    return TRUE;
}

BOOL CBrowserToolbarOptions::GetCurrentSkinPreviewPath(IN OUT TCHAR* Path,IN SIZE_T PathMaxSize)
{
    *Path=0;

    if (!this->bUseSkin)
        return FALSE;
    if (*this->SkinPreview==0)
        return FALSE;
    CStdFileOperations::GetAbsolutePath(this->CurrentSkinPath,this->SkinPreview,Path,(DWORD)PathMaxSize);
    return TRUE;
}
