/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#include "ShellBrowserContainer.h"
#include "../Tools/gui/ShellBrowser/DesktopBrowser.h"
#include "../Tools/ShellChangeNotifications/IShellChangeNotifications.h"

class CDesktopBrowserContainer : public CShellBrowserContainer, public IShellItemChangeWatcher
{
protected:
    void GetRect(BOOL bSmallView,RECT* pRect);
    BOOL ApplySettingsToClassObject(CSingleFolderOptions* pSingleFolderOptions);
    virtual BOOL DoesIconsPositionsNeedToBeSaved(LPITEMIDLIST CurrentPidl,LPITEMIDLIST ToBeBrowsePidl);
    virtual BOOL DoesIconsPositionsNeedToBeRestored();
    virtual BOOL DoesIconsPositionsNeedToBeSaved();

public:
    CDesktopBrowserContainer(HINSTANCE hInstance,CQuickWayToFolders* pQuickWayToFolders);
    ~CDesktopBrowserContainer(void);

    CDesktopBrowser* pDesktopBrowser;
    virtual void OnChangeNotify(long const lEvent, TCHAR* const sz1, TCHAR* const sz2);// defines IShellChangeNotifications::OnChangeNotify
    virtual LRESULT OnMessage(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);// overrides CShellBrowserContainerBase::OnMessage
    virtual void Destroy(); // overrides CShellBrowserContainer::Destroy
    virtual BOOL ApplySettings(CSingleFolderOptions* pSingleFolderOptions);// overrides CShellBrowserContainer::ApplySettings
    virtual HRESULT GoHome();
};
