/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#include "ContainerBase.h"
#include "../Tools/gui/FolderMenu/FolderMenu.h"
#include "../Tools/ShellChangeNotifications/IShellChangeNotifications.h"

#define CFolderMenuContainer_WM_SHELL_CHANGE_NOTIFY (WM_APP+1234)
#define CFolderMenuContainer_ITEM_CHANGED_DELAY 500
#define CFolderMenuContainer_ITEM_CHANGED_TIMER_ID 2345
class CFolderMenuContainer : public CContainerBase, public IShellItemChangeWatcher
{
protected:
    BOOL ApplySettingsToClassObject(CSingleFolderOptions* pSingleFolderOptions);
    virtual BOOL ReturnHandleToOwnerWindowAfterShow();
    void FreeMemory();
    CFolderMenu* pFolderMenu;
    CSingleFolderOptions* pAssociatedSingleFolderOptions;
    BOOL bFoldersContentChanged;
    virtual void OnChangeNotify(long const lEvent, TCHAR* const sz1, TCHAR* const sz2);
    static LRESULT CALLBACK HookWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,UINT_PTR uIdSubclass,DWORD_PTR dwRefData);
    BOOL AddEventHooks();
    BOOL RemoveEventsHooks();
    BOOL FillMenus();

public:
    CFolderMenuContainer(HINSTANCE hInstance,CQuickWayToFolders* pQuickWayToFolders);
    virtual ~CFolderMenuContainer(void);

    virtual void Destroy(); // overrides CContainerBase::Destroy
    virtual BOOL ApplySettings(CSingleFolderOptions* pSingleFolderOptions);// overrides CContainerBase::ApplySettings
    virtual BOOL Show(BOOL bShowOnly);// overrides CContainerBase::Show
    virtual BOOL Hide();// overrides CContainerBase::Hide
    virtual BOOL UpdateOptionsBeforeClose(){return TRUE;}
};
