/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "Language.h"

CLanguage::CLanguage(void)
{
    // default values in case of no language file
    _tcscpy(this->FolderNotFound,_T("Folder Not Found"));
    _tcscpy(this->Show,_T("Show"));
    _tcscpy(this->Options,_T("Options"));
    _tcscpy(this->Help,_T("Help"));
    _tcscpy(this->About,_T("About"));
    _tcscpy(this->MakeADonation,_T("Make A Donation"));
    _tcscpy(this->Exit,_T("Exit"));
    _tcscpy(this->CheckForUpdate,_T("Check For Update"));
    _tcscpy(this->Add,_T("Add"));
    _tcscpy(this->Remove,_T("Remove"));
    _tcscpy(this->Folders,_T("Folders"));
    _tcscpy(this->Horizontal,_T("Horizontal"));
    _tcscpy(this->Vertical,_T("Vertical"));
    _tcscpy(this->Diagonal,_T("Diagonal"));
    _tcscpy(this->BackwardDiagonal,_T("Backward Diagonal"));
    _tcscpy(this->Stretched,_T("Stretched"));
    _tcscpy(this->Centered,_T("Centered"));
    _tcscpy(this->UpLeft,_T("Up Left"));
    _tcscpy(this->UpCenter,_T("Up Center"));
    _tcscpy(this->UpRight,_T("Up Right"));
    _tcscpy(this->Left,_T("Left"));
    _tcscpy(this->Right,_T("Right"));
    _tcscpy(this->BottomLeft,_T("Bottom Left"));
    _tcscpy(this->BottomCenter,_T("Bottom Center"));
    _tcscpy(this->BottomRight,_T("Bottom Right"));
    _tcscpy(this->Icons,_T("Icons"));
    _tcscpy(this->SmallIcons,_T("Small Icons"));
    _tcscpy(this->List,_T("List"));
    _tcscpy(this->Detail,_T("Detail"));
    _tcscpy(this->Thumbnails,_T("Thumbnails"));
    _tcscpy(this->Tiles,_T("Tiles"));
    _tcscpy(this->ThumbStrip,_T("ThumbStrip"));
    _tcscpy(this->Type,_T("Type"));
    _tcscpy(this->SystemSpecialPath,_T("System Special Path"));
    _tcscpy(this->LocalOrRelativePath,_T("Local Or Relative Path"));
    _tcscpy(this->UnsupportedImageFormat,_T("Unsupported Image Format"));
    _tcscpy(this->BrowsingOptions,_T("Browsing Options"));
    _tcscpy(this->FileFilters,_T("File Filters"));
    _tcscpy(this->Customization,_T("Customization"));
    _tcscpy(this->MoveUp,_T("Up"));
    _tcscpy(this->MoveDown,_T("Down"));
    _tcscpy(this->NoFolderSelected,_T("No Folder Selected"));
    _tcscpy(this->Error,_T("Error"));
    _tcscpy(this->ForMoreInformations,_T("For more informations"));
    _tcscpy(this->See,_T("see"));
    _tcscpy(this->ProjectHomePage,_T("project homepage"));
    _tcscpy(this->Or,_T("or"));
    _tcscpy(this->UserManual,_T("user manual"));
    _tcscpy(this->Author,_T("Author"));
    _tcscpy(this->ShortcutType,_T("Shortcut Type"));
    _tcscpy(this->Desktop,_T("Desktop"));
    _tcscpy(this->Browser,_T("Browser"));
    _tcscpy(this->Menu,_T("Menu"));
    _tcscpy(this->MultipleFoldersMenu,_T("Multiple Folders Menu"));
    _tcscpy(this->AssociatedIcon,_T("Associated Icon"));
    _tcscpy(this->Ok,_T("Ok"));
    _tcscpy(this->Cancel,_T("Cancel"));
    _tcscpy(this->Background,_T("Background"));
    _tcscpy(this->None,_T("None"));
    _tcscpy(this->Color,_T("Color"));
    _tcscpy(this->Gradiant,_T("Gradiant"));
    _tcscpy(this->Picture,_T("Picture"));
    _tcscpy(this->Color1,_T("Color 1"));
    _tcscpy(this->Color2,_T("Color 2"));
    _tcscpy(this->ApplicationOptions,_T("Application Options"));
    _tcscpy(this->ConfigurationType,_T("Configuration Type"));
    _tcscpy(this->SingleUser,_T("Single User"));
    _tcscpy(this->MultipleUsers,_T("Multiple Users"));
    _tcscpy(this->LaunchAtWindowsStartup,_T("Launch At Windows Startup"));
    _tcscpy(this->LaunchMode,_T("Launch Mode"));
    _tcscpy(this->NotifyIcon,_T("Tray Icons"));
    _tcscpy(this->LaunchBar,_T("Launch Bar"));
    _tcscpy(this->IncludeSubfolders,_T("Include Subfolders"));
    _tcscpy(this->HideFilesExtensions,_T("Hide Files Extensions"));
    _tcscpy(this->HideShortcutsOverlay,_T("Hide Shortcuts Overlay"));
    _tcscpy(this->RememberLastPosition,_T("Remember Last Position"));
    _tcscpy(this->SingleClickSelection,_T("Single Click Selection"));
    _tcscpy(this->AutoHideOnExecution,_T("Auto Hide On Execution"));
    _tcscpy(this->ViewType,_T("View Type"));
    _tcscpy(this->TextColor,_T("Text Color"));
    _tcscpy(this->BackgroundColor,_T("Background Color"));
    _tcscpy(this->ExclusionFilters,_T("Exclusion Filters     (*.ini;*.htm)"));
    _tcscpy(this->InclusionFilters,_T("Inclusion Filters     (*.exe;*.jpg;*.m3u)"));
    _tcscpy(this->Language,_T("Language"));
    _tcscpy(this->Skin,_T("Skin"));
    _tcscpy(this->Path,_T("Path"));
    _tcscpy(this->Position,_T("Position"));
    _tcscpy(this->ZOrder,_T("Z Order"));
    _tcscpy(this->Normal,_T("Normal"));
    _tcscpy(this->TopMost,_T("Top Most"));
    _tcscpy(this->ZBottom,_T("Bottom"));
    _tcscpy(this->Bottom,_T("Bottom"));
    _tcscpy(this->HideToolBar,_T("Hide ToolBar"));
    _tcscpy(this->HideToolBarForHomeFolder,_T("Hide ToolBar For Home Folder"));
    _tcscpy(this->Hide,_T("Hide"));
    _tcscpy(this->Maximize,_T("Maximize"));
    _tcscpy(this->Reduce,_T("Reduce"));
    _tcscpy(this->SaveIconsPositionsForHomeFolder,_T("Save Icons Positions For Home Folder"));
    _tcscpy(this->ShowAtStartup,_T("Show At Startup"));
    _tcscpy(this->StartMaximized,_T("Start Maximized"));
    _tcscpy(this->Medium ,_T("Medium"));
    _tcscpy(this->Large,_T("Large"));
    _tcscpy(this->ExtraLarge,_T("ExtraLarge"));
    _tcscpy(this->ShowHideHotKey,_T("Show / Hide HotKey"));
    _tcscpy(this->Name,_T("Name"));
    _tcscpy(this->LaunchBarSpecific   ,_T("Launch Bar Specific"));
    _tcscpy(this->OverIcon            ,_T("Over"));
    _tcscpy(this->PressedIcon         ,_T("Pressed"));
    _tcscpy(this->Monitor             ,_T("Monitor"));
    _tcscpy(this->Direction           ,_T("Direction"));
    _tcscpy(this->UseFullWidthHeight  ,_T("Use Full Width/Height"));
    _tcscpy(this->IconsSize           ,_T("Icons Size"));
    _tcscpy(this->UseTransparentColor ,_T("Use Transparent Color"));
    _tcscpy(this->Opacity             ,_T("Opacity"));
    _tcscpy(this->ActiveAreaThickness ,_T("Active Area Thickness"));
    _tcscpy(this->MinWidth            ,_T("Min Width"));
    _tcscpy(this->MinHeight           ,_T("Min Height"));
    _tcscpy(this->Margins             ,_T("Margins"));
    _tcscpy(this->Top                 ,_T("Top"));
    _tcscpy(this->EnableHotCorner     ,_T("Enable Hot Corner"));
    _tcscpy(this->HotCorner           ,_T("Hot Corner"));
    _tcscpy(this->Width               ,_T("Width"));
    _tcscpy(this->Height              ,_T("Height"));
    _tcscpy(this->LeftOrTop           ,_T("Left / Top"));
    _tcscpy(this->CenterOrMiddle      ,_T("Center / Middle"));
    _tcscpy(this->RightOrBottom       ,_T("Right / Bottom"));
    _tcscpy(this->SpaceBeforeIcon     ,_T("Space Before Icon"));
    _tcscpy(this->AllowSubfoldersNavigation,_T("Allow Subfolders Navigation"));
    _tcscpy(this->AllowSubfoldersLinksNavigation,_T("Allow Subfolders Links Navigation"));
    _tcscpy(this->MergeMenus          ,_T("Merge Folders Into Single Menu"));
    _tcscpy(this->FoldersPositionInPopupMenu ,_T("Folders Position In Popup Menu"));
    _tcscpy(this->MixedWithFiles      ,_T("Mixed With Files"));
    _tcscpy(this->GoToHomeFolder      ,_T("Go to home folder"));
    _tcscpy(this->GoBack              ,_T("Go back"));
    _tcscpy(this->GoForward           ,_T("Go forward"));
    _tcscpy(this->GoUp                ,_T("Go up"));
    _tcscpy(this->OpenFolderWithWindowsExplorer ,_T("Open folder with windows explorer"));
    _tcscpy(this->Move                ,_T("Move"));
    _tcscpy(this->Close               ,_T("Close"));
    _tcscpy(this->Merged                 ,_T("Merged"));
    _tcscpy(this->MergeToSpecificFolder  ,_T("Merge to specific folder"));
    _tcscpy(this->EmptyMergedFolderName  ,_T("Empty merged Folder Name"));


//    _tcscpy(this->,_T(""));
}

CLanguage::~CLanguage(void)
{
}

void CLanguage::Clone(IN OUT CLanguage* pLanguage)
{
    // dirty copy
    memcpy(pLanguage,this,sizeof(CLanguage));
}

BOOL CLanguage::Save(CIniFile* pIniFile)
{

    pIniFile->Set(CLanguage_FolderNotFound             ,this->FolderNotFound           );
    pIniFile->Set(CLanguage_Show                       ,this->Show                     );
    pIniFile->Set(CLanguage_Options                    ,this->Options                  );
    pIniFile->Set(CLanguage_Help                       ,this->Help                     );
    pIniFile->Set(CLanguage_About                      ,this->About                    );
    pIniFile->Set(CLanguage_MakeADonation              ,this->MakeADonation            );
    pIniFile->Set(CLanguage_Exit                       ,this->Exit                     );
    pIniFile->Set(CLanguage_CheckForUpdate             ,this->CheckForUpdate           );
    pIniFile->Set(CLanguage_Add                        ,this->Add                      );
    pIniFile->Set(CLanguage_Remove                     ,this->Remove                   );
    pIniFile->Set(CLanguage_Folders                    ,this->Folders                  );
    pIniFile->Set(CLanguage_Horizontal                 ,this->Horizontal               );
    pIniFile->Set(CLanguage_Vertical                   ,this->Vertical                 );
    pIniFile->Set(CLanguage_Diagonal                   ,this->Diagonal                 );
    pIniFile->Set(CLanguage_BackwardDiagonal           ,this->BackwardDiagonal         );
    pIniFile->Set(CLanguage_Stretched                  ,this->Stretched                );
    pIniFile->Set(CLanguage_Centered                   ,this->Centered                 );
    pIniFile->Set(CLanguage_UpLeft                     ,this->UpLeft                   );
    pIniFile->Set(CLanguage_UpCenter                   ,this->UpCenter                 );
    pIniFile->Set(CLanguage_UpRight                    ,this->UpRight                  );
    pIniFile->Set(CLanguage_Left                       ,this->Left                     );
    pIniFile->Set(CLanguage_Right                      ,this->Right                    );
    pIniFile->Set(CLanguage_BottomLeft                 ,this->BottomLeft               );
    pIniFile->Set(CLanguage_BottomCenter               ,this->BottomCenter             );
    pIniFile->Set(CLanguage_BottomRight                ,this->BottomRight              );
    pIniFile->Set(CLanguage_Icons                      ,this->Icons                    );
    pIniFile->Set(CLanguage_SmallIcons                 ,this->SmallIcons               );
    pIniFile->Set(CLanguage_List                       ,this->List                     );
    pIniFile->Set(CLanguage_Detail                     ,this->Detail                   );
    pIniFile->Set(CLanguage_Thumbnails                 ,this->Thumbnails               );
    pIniFile->Set(CLanguage_Tiles                      ,this->Tiles                    );
    pIniFile->Set(CLanguage_ThumbStrip                 ,this->ThumbStrip               );
    pIniFile->Set(CLanguage_Type                       ,this->Type                     );
    pIniFile->Set(CLanguage_SystemSpecialPath          ,this->SystemSpecialPath        );
    pIniFile->Set(CLanguage_LocalOrRelativePath        ,this->LocalOrRelativePath      );
    pIniFile->Set(CLanguage_UnsupportedImageFormat     ,this->UnsupportedImageFormat   );
    pIniFile->Set(CLanguage_BrowsingOptions            ,this->BrowsingOptions          );
    pIniFile->Set(CLanguage_FileFilters                ,this->FileFilters              );
    pIniFile->Set(CLanguage_Customization              ,this->Customization            );
    pIniFile->Set(CLanguage_MoveUp                     ,this->MoveUp                   );
    pIniFile->Set(CLanguage_MoveDown                   ,this->MoveDown                 );
    pIniFile->Set(CLanguage_NoFolderSelected           ,this->NoFolderSelected         );
    pIniFile->Set(CLanguage_Error                      ,this->Error                    );
    pIniFile->Set(CLanguage_ForMoreInformations        ,this->ForMoreInformations      );
    pIniFile->Set(CLanguage_See                        ,this->See                      );
    pIniFile->Set(CLanguage_ProjectHomePage            ,this->ProjectHomePage          );
    pIniFile->Set(CLanguage_Or                         ,this->Or                       );
    pIniFile->Set(CLanguage_UserManual                 ,this->UserManual               );
    pIniFile->Set(CLanguage_Author                     ,this->Author                   );
    pIniFile->Set(CLanguage_ShortcutType               ,this->ShortcutType             );
    pIniFile->Set(CLanguage_Desktop                    ,this->Desktop                  );
    pIniFile->Set(CLanguage_Browser                    ,this->Browser                  );
    pIniFile->Set(CLanguage_Menu                       ,this->Menu                     );
    pIniFile->Set(CLanguage_MultipleFoldersMenu        ,this->MultipleFoldersMenu      );
    pIniFile->Set(CLanguage_AssociatedIcon             ,this->AssociatedIcon           );
    pIniFile->Set(CLanguage_Ok                         ,this->Ok                       );
    pIniFile->Set(CLanguage_Cancel                     ,this->Cancel                   );
    pIniFile->Set(CLanguage_Background                 ,this->Background               );
    pIniFile->Set(CLanguage_None                       ,this->None                     );
    pIniFile->Set(CLanguage_Color                      ,this->Color                    );
    pIniFile->Set(CLanguage_Gradiant                   ,this->Gradiant                 );
    pIniFile->Set(CLanguage_Picture                    ,this->Picture                  );
    pIniFile->Set(CLanguage_Color1                     ,this->Color1                   );
    pIniFile->Set(CLanguage_Color2                     ,this->Color2                   );
    pIniFile->Set(CLanguage_ApplicationOptions         ,this->ApplicationOptions       );
    pIniFile->Set(CLanguage_ConfigurationType          ,this->ConfigurationType        );
    pIniFile->Set(CLanguage_SingleUser                 ,this->SingleUser               );
    pIniFile->Set(CLanguage_MultipleUsers              ,this->MultipleUsers            );
    pIniFile->Set(CLanguage_LaunchAtWindowsStartup     ,this->LaunchAtWindowsStartup   );
    pIniFile->Set(CLanguage_LaunchMode                 ,this->LaunchMode               );
    pIniFile->Set(CLanguage_NotifyIcon                 ,this->NotifyIcon               );
    pIniFile->Set(CLanguage_LaunchBar                  ,this->LaunchBar                );
    pIniFile->Set(CLanguage_IncludeSubfolders          ,this->IncludeSubfolders        );
    pIniFile->Set(CLanguage_AllowSubfoldersNavigation  ,this->AllowSubfoldersNavigation);
    pIniFile->Set(CLanguage_AllowSubfoldersLinksNavigation  ,this->AllowSubfoldersLinksNavigation);
    pIniFile->Set(CLanguage_HideFilesExtensions        ,this->HideFilesExtensions      );
    pIniFile->Set(CLanguage_HideShortcutsOverlay       ,this->HideShortcutsOverlay     );
    pIniFile->Set(CLanguage_RememberLastPosition       ,this->RememberLastPosition     );
    pIniFile->Set(CLanguage_SingleClickSelection       ,this->SingleClickSelection     );
    pIniFile->Set(CLanguage_AutoHideOnExecution        ,this->AutoHideOnExecution      );
    pIniFile->Set(CLanguage_ViewType                   ,this->ViewType                 );
    pIniFile->Set(CLanguage_TextColor                  ,this->TextColor                );
    pIniFile->Set(CLanguage_BackgroundColor            ,this->BackgroundColor          );
    pIniFile->Set(CLanguage_ExclusionFilters           ,this->ExclusionFilters         );
    pIniFile->Set(CLanguage_InclusionFilters           ,this->InclusionFilters         );
    pIniFile->Set(CLanguage_Language                   ,this->Language                 );
    pIniFile->Set(CLanguage_Skin                       ,this->Skin                     );
    pIniFile->Set(CLanguage_Path                       ,this->Path                     );
    pIniFile->Set(CLanguage_Position                   ,this->Position                 );
    pIniFile->Set(CLanguage_ZOrder                     ,this->ZOrder                   );
    pIniFile->Set(CLanguage_Normal                     ,this->Normal                   );
    pIniFile->Set(CLanguage_TopMost                    ,this->TopMost                  );
    pIniFile->Set(CLanguage_Bottom                     ,this->Bottom                   );
    pIniFile->Set(CLanguage_ZBottom                    ,this->ZBottom                  );
    pIniFile->Set(CLanguage_HideToolBarForHomeFolder   ,this->HideToolBarForHomeFolder );
    pIniFile->Set(CLanguage_HideToolBar                ,this->HideToolBar              );
    pIniFile->Set(CLanguage_Hide                       ,this->Hide                     );
    pIniFile->Set(CLanguage_Maximize                   ,this->Maximize                 );
    pIniFile->Set(CLanguage_Reduce                     ,this->Reduce                   );
    pIniFile->Set(CLanguage_SaveIconsPositionsForHomeFolder ,this->SaveIconsPositionsForHomeFolder );
    pIniFile->Set(CLanguage_ShowAtStartup              ,this->ShowAtStartup            );
    pIniFile->Set(CLanguage_StartMaximized             ,this->StartMaximized           );
    pIniFile->Set(CLanguage_Medium                     ,this->Medium                   );
    pIniFile->Set(CLanguage_Large                      ,this->Large                    );
    pIniFile->Set(CLanguage_ExtraLarge                 ,this->ExtraLarge               );
    pIniFile->Set(CLanguage_ExtraLarge                 ,this->ExtraLarge               );
    pIniFile->Set(CLanguage_ShowHideHotKey             ,this->ShowHideHotKey           );
    pIniFile->Set(CLanguage_Name                       ,this->Name                     );
    pIniFile->Set(CLanguage_LaunchBarSpecific          ,this->LaunchBarSpecific        );
    pIniFile->Set(CLanguage_OverIcon                   ,this->OverIcon                 );
    pIniFile->Set(CLanguage_PressedIcon                ,this->PressedIcon              );
    pIniFile->Set(CLanguage_Monitor                    ,this->Monitor                  );
    pIniFile->Set(CLanguage_Direction                  ,this->Direction                );
    pIniFile->Set(CLanguage_UseFullWidthHeight         ,this->UseFullWidthHeight       );
    pIniFile->Set(CLanguage_IconsSize                  ,this->IconsSize                );
    pIniFile->Set(CLanguage_UseTransparentColor        ,this->UseTransparentColor      );
    pIniFile->Set(CLanguage_Opacity                    ,this->Opacity                  );
    pIniFile->Set(CLanguage_ActiveAreaThickness        ,this->ActiveAreaThickness      );
    pIniFile->Set(CLanguage_MinWidth                   ,this->MinWidth                 );
    pIniFile->Set(CLanguage_MinHeight                  ,this->MinHeight                );
    pIniFile->Set(CLanguage_Margins                    ,this->Margins                  );
    pIniFile->Set(CLanguage_Top                        ,this->Top                      );
    pIniFile->Set(CLanguage_EnableHotCorner            ,this->EnableHotCorner          );
    pIniFile->Set(CLanguage_HotCorner                  ,this->HotCorner                );
    pIniFile->Set(CLanguage_Width                      ,this->Width                    );
    pIniFile->Set(CLanguage_Height                     ,this->Height                   );
    pIniFile->Set(CLanguage_LeftOrTop                  ,this->LeftOrTop                );
    pIniFile->Set(CLanguage_CenterOrMiddle             ,this->CenterOrMiddle           );
    pIniFile->Set(CLanguage_RightOrBottom              ,this->RightOrBottom            );
    pIniFile->Set(CLanguage_SpaceBeforeIcon            ,this->SpaceBeforeIcon          );
    pIniFile->Set(CLanguage_MergeMenus                 ,this->MergeMenus                 );
    pIniFile->Set(CLanguage_FoldersPositionInPopupMenu ,this->FoldersPositionInPopupMenu );
    pIniFile->Set(CLanguage_MixedWithFiles             ,this->MixedWithFiles             );
    pIniFile->Set(CLanguage_GoToHomeFolder             ,this->GoToHomeFolder            );
    pIniFile->Set(CLanguage_GoBack                     ,this->GoBack                    );
    pIniFile->Set(CLanguage_GoForward                  ,this->GoForward                 );
    pIniFile->Set(CLanguage_GoUp                       ,this->GoUp                      );
    pIniFile->Set(CLanguage_OpenFolderWithWindowsExplorer ,this->OpenFolderWithWindowsExplorer );
    pIniFile->Set(CLanguage_Move                       ,this->Move                      );
    pIniFile->Set(CLanguage_Close                      ,this->Close                     );
    pIniFile->Set(CLanguage_Merged                     ,this->Merged                    );
    pIniFile->Set(CLanguage_MergeToSpecificFolder      ,this->MergeToSpecificFolder     );
    pIniFile->Set(CLanguage_EmptyMergedFolderName      ,this->EmptyMergedFolderName     );

    
    return TRUE;
}
BOOL CLanguage::Load(CIniFile* pIniFile)
{
    // as constructor already fills default value, we can use existing value as default value and so use
    // pIniFile->Get(key,this->X,this->X,Size);

    pIniFile->Get(CLanguage_FolderNotFound             ,this->FolderNotFound           ,this->FolderNotFound           ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Show                       ,this->Show                     ,this->Show                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Options                    ,this->Options                  ,this->Options                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Help                       ,this->Help                     ,this->Help                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_About                      ,this->About                    ,this->About                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MakeADonation              ,this->MakeADonation            ,this->MakeADonation            ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Exit                       ,this->Exit                     ,this->Exit                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_CheckForUpdate             ,this->CheckForUpdate           ,this->CheckForUpdate           ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Add                        ,this->Add                      ,this->Add                      ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Remove                     ,this->Remove                   ,this->Remove                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Folders                    ,this->Folders                  ,this->Folders                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Horizontal                 ,this->Horizontal               ,this->Horizontal               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Vertical                   ,this->Vertical                 ,this->Vertical                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Diagonal                   ,this->Diagonal                 ,this->Diagonal                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_BackwardDiagonal           ,this->BackwardDiagonal         ,this->BackwardDiagonal         ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Stretched                  ,this->Stretched                ,this->Stretched                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Centered                   ,this->Centered                 ,this->Centered                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UpLeft                     ,this->UpLeft                   ,this->UpLeft                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UpCenter                   ,this->UpCenter                 ,this->UpCenter                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UpRight                    ,this->UpRight                  ,this->UpRight                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Left                       ,this->Left                     ,this->Left                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Right                      ,this->Right                    ,this->Right                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_BottomLeft                 ,this->BottomLeft               ,this->BottomLeft               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_BottomCenter               ,this->BottomCenter             ,this->BottomCenter             ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_BottomRight                ,this->BottomRight              ,this->BottomRight              ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Icons                      ,this->Icons                    ,this->Icons                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_SmallIcons                 ,this->SmallIcons               ,this->SmallIcons               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_List                       ,this->List                     ,this->List                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Detail                     ,this->Detail                   ,this->Detail                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Thumbnails                 ,this->Thumbnails               ,this->Thumbnails               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Tiles                      ,this->Tiles                    ,this->Tiles                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ThumbStrip                 ,this->ThumbStrip               ,this->ThumbStrip               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Type                       ,this->Type                     ,this->Type                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_SystemSpecialPath          ,this->SystemSpecialPath        ,this->SystemSpecialPath        ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_LocalOrRelativePath        ,this->LocalOrRelativePath      ,this->LocalOrRelativePath      ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UnsupportedImageFormat     ,this->UnsupportedImageFormat   ,this->UnsupportedImageFormat   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_BrowsingOptions            ,this->BrowsingOptions          ,this->BrowsingOptions          ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_FileFilters                ,this->FileFilters              ,this->FileFilters              ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Customization              ,this->Customization            ,this->Customization            ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MoveUp                     ,this->MoveUp                   ,this->MoveUp                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MoveDown                   ,this->MoveDown                 ,this->MoveDown                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_NoFolderSelected           ,this->NoFolderSelected         ,this->NoFolderSelected         ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Error                      ,this->Error                    ,this->Error                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ForMoreInformations        ,this->ForMoreInformations      ,this->ForMoreInformations      ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_See                        ,this->See                      ,this->See                      ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ProjectHomePage            ,this->ProjectHomePage          ,this->ProjectHomePage          ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Or                         ,this->Or                       ,this->Or                       ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UserManual                 ,this->UserManual               ,this->UserManual               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Author                     ,this->Author                   ,this->Author                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ShortcutType               ,this->ShortcutType             ,this->ShortcutType             ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Desktop                    ,this->Desktop                  ,this->Desktop                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Browser                    ,this->Browser                  ,this->Browser                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Menu                       ,this->Menu                     ,this->Menu                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MultipleFoldersMenu        ,this->MultipleFoldersMenu      ,this->MultipleFoldersMenu      ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_AssociatedIcon             ,this->AssociatedIcon           ,this->AssociatedIcon           ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Ok                         ,this->Ok                       ,this->Ok                       ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Cancel                     ,this->Cancel                   ,this->Cancel                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Background                 ,this->Background               ,this->Background               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_None                       ,this->None                     ,this->None                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Color                      ,this->Color                    ,this->Color                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Gradiant                   ,this->Gradiant                 ,this->Gradiant                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Picture                    ,this->Picture                  ,this->Picture                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Color1                     ,this->Color1                   ,this->Color1                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Color2                     ,this->Color2                   ,this->Color2                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ApplicationOptions         ,this->ApplicationOptions       ,this->ApplicationOptions       ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ConfigurationType          ,this->ConfigurationType        ,this->ConfigurationType        ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_SingleUser                 ,this->SingleUser               ,this->SingleUser               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MultipleUsers              ,this->MultipleUsers            ,this->MultipleUsers            ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_LaunchAtWindowsStartup     ,this->LaunchAtWindowsStartup   ,this->LaunchAtWindowsStartup   ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_LaunchMode                 ,this->LaunchMode               ,this->LaunchMode               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_NotifyIcon                 ,this->NotifyIcon               ,this->NotifyIcon               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_LaunchBar                  ,this->LaunchBar                ,this->LaunchBar                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_IncludeSubfolders          ,this->IncludeSubfolders        ,this->IncludeSubfolders        ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_AllowSubfoldersNavigation  ,this->AllowSubfoldersNavigation,this->AllowSubfoldersNavigation,CLanguage_LargeNameSize);
    pIniFile->Get(CLanguage_AllowSubfoldersLinksNavigation,this->AllowSubfoldersLinksNavigation,this->AllowSubfoldersLinksNavigation,CLanguage_LargeNameSize);
    pIniFile->Get(CLanguage_HideFilesExtensions        ,this->HideFilesExtensions      ,this->HideFilesExtensions      ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_HideShortcutsOverlay       ,this->HideShortcutsOverlay     ,this->HideShortcutsOverlay     ,CLanguage_LargeNameSize);
    pIniFile->Get(CLanguage_RememberLastPosition       ,this->RememberLastPosition     ,this->RememberLastPosition     ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_SingleClickSelection       ,this->SingleClickSelection     ,this->SingleClickSelection     ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_AutoHideOnExecution        ,this->AutoHideOnExecution      ,this->AutoHideOnExecution      ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_ViewType                   ,this->ViewType                 ,this->ViewType                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_TextColor                  ,this->TextColor                ,this->TextColor                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_BackgroundColor            ,this->BackgroundColor          ,this->BackgroundColor          ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ExclusionFilters           ,this->ExclusionFilters         ,this->ExclusionFilters         ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_InclusionFilters           ,this->InclusionFilters         ,this->InclusionFilters         ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Language                   ,this->Language                 ,this->Language                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Skin                       ,this->Skin                     ,this->Skin                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Path                       ,this->Path                     ,this->Path                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Position                   ,this->Position                 ,this->Position                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ZOrder                     ,this->ZOrder                   ,this->ZOrder                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Normal                     ,this->Normal                   ,this->Normal                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_TopMost                    ,this->TopMost                  ,this->TopMost                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ZBottom                    ,this->ZBottom                  ,this->ZBottom                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Bottom                     ,this->Bottom                   ,this->Bottom                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_HideToolBarForHomeFolder   ,this->HideToolBarForHomeFolder ,this->HideToolBarForHomeFolder ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_HideToolBar                ,this->HideToolBar              ,this->HideToolBar              ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Hide                       ,this->Hide                     ,this->Hide                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Maximize                   ,this->Maximize                 ,this->Maximize                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Reduce                     ,this->Reduce                   ,this->Reduce                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_SaveIconsPositionsForHomeFolder ,this->SaveIconsPositionsForHomeFolder ,this->SaveIconsPositionsForHomeFolder,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_ShowAtStartup              ,this->ShowAtStartup            ,this->ShowAtStartup            ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_StartMaximized             ,this->StartMaximized           ,this->StartMaximized           ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Large                      ,this->Large                    ,this->Large                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Medium                     ,this->Medium                   ,this->Medium                   ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ExtraLarge                 ,this->ExtraLarge               ,this->ExtraLarge               ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ShowHideHotKey             ,this->ShowHideHotKey           ,this->ShowHideHotKey           ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Name                       ,this->Name                     ,this->Name                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_LaunchBarSpecific          ,this->LaunchBarSpecific        ,this->LaunchBarSpecific        ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_OverIcon                   ,this->OverIcon                 ,this->OverIcon                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_PressedIcon                ,this->PressedIcon              ,this->PressedIcon              ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Monitor                    ,this->Monitor                  ,this->Monitor                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Direction                  ,this->Direction                ,this->Direction                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UseFullWidthHeight         ,this->UseFullWidthHeight       ,this->UseFullWidthHeight       ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_IconsSize                  ,this->IconsSize                ,this->IconsSize                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_UseTransparentColor        ,this->UseTransparentColor      ,this->UseTransparentColor      ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Opacity                    ,this->Opacity                  ,this->Opacity                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_ActiveAreaThickness        ,this->ActiveAreaThickness      ,this->ActiveAreaThickness      ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_MinWidth                   ,this->MinWidth                 ,this->MinWidth                 ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MinHeight                  ,this->MinHeight                ,this->MinHeight                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Margins                    ,this->Margins                  ,this->Margins                  ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Top                        ,this->Top                      ,this->Top                      ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_EnableHotCorner            ,this->EnableHotCorner          ,this->EnableHotCorner          ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_HotCorner                  ,this->HotCorner                ,this->HotCorner                ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Width                      ,this->Width                    ,this->Width                    ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_Height                     ,this->Height                   ,this->Height                   ,CLanguage_ShortNameSize);    
    pIniFile->Get(CLanguage_LeftOrTop                  ,this->LeftOrTop                ,this->LeftOrTop                ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_CenterOrMiddle             ,this->CenterOrMiddle           ,this->CenterOrMiddle           ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_RightOrBottom              ,this->RightOrBottom            ,this->RightOrBottom            ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_SpaceBeforeIcon            ,this->SpaceBeforeIcon          ,this->SpaceBeforeIcon          ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_MergeMenus                 ,this->MergeMenus                 ,this->MergeMenus                 ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_FoldersPositionInPopupMenu ,this->FoldersPositionInPopupMenu ,this->FoldersPositionInPopupMenu ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_MixedWithFiles             ,this->MixedWithFiles             ,this->MixedWithFiles             ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_GoToHomeFolder             ,this->GoToHomeFolder             ,this->GoToHomeFolder             ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_GoBack                     ,this->GoBack                     ,this->GoBack                     ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_GoForward                  ,this->GoForward                  ,this->GoForward                  ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_GoUp                       ,this->GoUp                       ,this->GoUp                       ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_OpenFolderWithWindowsExplorer ,this->OpenFolderWithWindowsExplorer ,this->OpenFolderWithWindowsExplorer ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Move                       ,this->Move                       ,this->Move                       ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Close                      ,this->Close                      ,this->Close                      ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_Merged                     ,this->Merged                     ,this->Merged                     ,CLanguage_ShortNameSize);
    pIniFile->Get(CLanguage_MergeToSpecificFolder      ,this->MergeToSpecificFolder      ,this->MergeToSpecificFolder      ,CLanguage_MediumNameSize);
    pIniFile->Get(CLanguage_EmptyMergedFolderName      ,this->EmptyMergedFolderName      ,this->EmptyMergedFolderName      ,CLanguage_MediumNameSize);

    return TRUE;
}

