/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#include "../Tools/Ini/IniFileEx.h"

#define CLanguage_ShortNameSize 64
#define CLanguage_MediumNameSize 128
#define CLanguage_LargeNameSize 256

#define CLanguage_FolderNotFound                _T("FolderNotFound")    
#define CLanguage_Show                          _T("Show")              
#define CLanguage_Options                       _T("Options")           
#define CLanguage_Help                          _T("Help")              
#define CLanguage_About                         _T("About")             
#define CLanguage_MakeADonation                 _T("MakeADonation")     
#define CLanguage_Exit                          _T("Exit")              
#define CLanguage_CheckForUpdate                _T("CheckForUpdate")    
#define CLanguage_Add                           _T("Add")               
#define CLanguage_Remove                        _T("Remove")            
#define CLanguage_Folders                       _T("Folders")           
#define CLanguage_Horizontal                    _T("Horizontal")        
#define CLanguage_Vertical                      _T("Vertical")          
#define CLanguage_Diagonal                      _T("Diagonal")          
#define CLanguage_BackwardDiagonal              _T("BackwardDiagonal")  
#define CLanguage_Stretched                     _T("Stretched")    
#define CLanguage_Centered                      _T("Centered")     
#define CLanguage_UpLeft                        _T("UpLeft")       
#define CLanguage_UpCenter                      _T("UpCenter")     
#define CLanguage_UpRight                       _T("UpRight")      
#define CLanguage_Left                          _T("Left")         
#define CLanguage_Right                         _T("Right")        
#define CLanguage_BottomLeft                    _T("BottomLeft")   
#define CLanguage_BottomCenter                  _T("BottomCenter") 
#define CLanguage_BottomRight                   _T("BottomRight")  
#define CLanguage_Icons                         _T("Icons")        
#define CLanguage_SmallIcons                    _T("SmallIcons")   
#define CLanguage_List                          _T("List")         
#define CLanguage_Detail                        _T("Detail")       
#define CLanguage_Thumbnails                    _T("Thumbnails")   
#define CLanguage_Tiles                         _T("Tiles")        
#define CLanguage_ThumbStrip                    _T("ThumbStrip")   
#define CLanguage_Type                          _T("Type")         
#define CLanguage_SystemSpecialPath             _T("SystemSpecialPath")     
#define CLanguage_LocalOrRelativePath           _T("LocalOrRelativePath")             
#define CLanguage_UnsupportedImageFormat        _T("UnsupportedImageFormat")
#define CLanguage_BrowsingOptions               _T("BrowsingOptions")       
#define CLanguage_FileFilters                   _T("FileFilters")           
#define CLanguage_Customization                 _T("Customization")         
#define CLanguage_MoveUp                        _T("MoveUp")                    
#define CLanguage_MoveDown                      _T("MoveDown")                  
#define CLanguage_NoFolderSelected              _T("NoFolderSelected")      
#define CLanguage_Error                         _T("Error")                 
#define CLanguage_ForMoreInformations           _T("ForMoreInformations")   
#define CLanguage_See                           _T("See")                   
#define CLanguage_ProjectHomePage               _T("ProjectHomePage")       
#define CLanguage_Or                            _T("Or")                    
#define CLanguage_UserManual                    _T("UserManual")            
#define CLanguage_Author                        _T("Author")                
#define CLanguage_ShortcutType                  _T("ShortcutType")            
#define CLanguage_Desktop                       _T("Desktop")               
#define CLanguage_Browser                       _T("Browser")                
#define CLanguage_Menu                          _T("Menu")                  
#define CLanguage_MultipleFoldersMenu           _T("MultipleFoldersMenu")   
#define CLanguage_AssociatedIcon                _T("AssociatedIcon")        
#define CLanguage_Ok                            _T("Ok")                    
#define CLanguage_Cancel                        _T("Cancel")                
#define CLanguage_Background                    _T("Background")            
#define CLanguage_None                          _T("None")                  
#define CLanguage_Color                         _T("Color")                 
#define CLanguage_Gradiant                      _T("Gradiant")              
#define CLanguage_Picture                       _T("Picture")               
#define CLanguage_Color1                        _T("Color1")                
#define CLanguage_Color2                        _T("Color2")                
#define CLanguage_ApplicationOptions            _T("ApplicationOptions")    
#define CLanguage_ConfigurationType             _T("ConfigurationType")     
#define CLanguage_SingleUser                    _T("SingleUser")            
#define CLanguage_MultipleUsers                 _T("MultipleUsers")         
#define CLanguage_LaunchAtWindowsStartup        _T("LaunchAtWindowsStartup")
#define CLanguage_LaunchMode                    _T("LaunchMode")  
#define CLanguage_NotifyIcon                    _T("NotifyIcon")
#define CLanguage_LaunchBar                     _T("LaunchBar")
#define CLanguage_IncludeSubfolders             _T("IncludeSubfolders")     
#define CLanguage_AllowSubfoldersNavigation     _T("AllowSubfoldersNavigation")
#define CLanguage_AllowSubfoldersLinksNavigation _T("AllowSubfoldersLinksNavigation")
#define CLanguage_HideFilesExtensions           _T("HideFilesExtensions")
#define CLanguage_HideShortcutsOverlay          _T("HideShortcutsOverlay")
#define CLanguage_RememberLastPosition          _T("RememberLastPosition")  
#define CLanguage_SingleClickSelection          _T("SingleClickSelection")  
#define CLanguage_AutoHideOnExecution           _T("AutoHideOnExecution")   
#define CLanguage_ViewType                      _T("ViewType")              
#define CLanguage_TextColor                     _T("TextColor")
#define CLanguage_BackgroundColor               _T("BackgroundColor")
#define CLanguage_ExclusionFilters              _T("ExclusionFilters")
#define CLanguage_InclusionFilters              _T("InclusionFilters")
#define CLanguage_Language                      _T("Language")
#define CLanguage_Skin                          _T("Skin")
#define CLanguage_Path                          _T("Path")
#define CLanguage_Position                      _T("Position")
#define CLanguage_ZOrder                        _T("ZOrder")
#define CLanguage_ZBottom                       _T("ZBottom")
#define CLanguage_Bottom                        _T("Bottom")
#define CLanguage_TopMost                       _T("TopMost")
#define CLanguage_Normal                        _T("Normal")
#define CLanguage_HideToolBarForHomeFolder      _T("HideToolBarForHomeFolder")
#define CLanguage_HideToolBar                   _T("HideToolBar")
#define CLanguage_Hide                          _T("Hide")
#define CLanguage_Maximize                      _T("Maximize")
#define CLanguage_Reduce                        _T("Reduce")
#define CLanguage_SaveIconsPositionsForHomeFolder _T("SaveIconsPositionsForHomeFolder")
#define CLanguage_ShowAtStartup                 _T("ShowAtStartup")
#define CLanguage_StartMaximized                _T("StartMaximized")
#define CLanguage_Medium                        _T("Medium")
#define CLanguage_Large                         _T("Large")
#define CLanguage_ExtraLarge                    _T("ExtraLarge")
#define CLanguage_ShowHideHotKey                _T("ShowHideHotKey")
#define CLanguage_Name                          _T("Name")
#define CLanguage_LaunchBarSpecific             _T("LaunchBarSpecific")
#define CLanguage_OverIcon                      _T("OverIcon")
#define CLanguage_PressedIcon                   _T("PressedIcon")
#define CLanguage_Monitor                       _T("Monitor")
#define CLanguage_Direction                     _T("Direction")
#define CLanguage_UseFullWidthHeight            _T("UseFullWidthHeight")
#define CLanguage_IconsSize                     _T("IconsSize")
#define CLanguage_UseTransparentColor           _T("UseTransparentColor")
#define CLanguage_Opacity                       _T("Opacity")
#define CLanguage_ActiveAreaThickness           _T("ActiveAreaThickness")
#define CLanguage_MinWidth                      _T("MinWidth")
#define CLanguage_MinHeight                     _T("MinHeight")
#define CLanguage_Margins                       _T("Margins")
#define CLanguage_Top                           _T("Top")
#define CLanguage_EnableHotCorner               _T("EnableHotCorner")
#define CLanguage_HotCorner                     _T("HotCorner")
#define CLanguage_Width                         _T("Width")
#define CLanguage_Height                        _T("Height")
#define CLanguage_LeftOrTop                     _T("LeftOrTop")
#define CLanguage_CenterOrMiddle                _T("CenterOrMiddle")
#define CLanguage_RightOrBottom                 _T("RightOrBottom")
#define CLanguage_SpaceBeforeIcon               _T("SpaceBeforeIcon")
#define CLanguage_MergeMenus                    _T("MergeMenus")
#define CLanguage_FoldersPositionInPopupMenu    _T("FoldersPositionInPopupMenu")
#define CLanguage_MixedWithFiles                _T("MixedWithFiles")
#define CLanguage_GoToHomeFolder                _T("GoToHomeFolder")
#define CLanguage_GoBack                        _T("GoBack")
#define CLanguage_GoForward                     _T("GoForward")
#define CLanguage_GoUp                          _T("GoUp")
#define CLanguage_OpenFolderWithWindowsExplorer _T("OpenFolderWithWindowsExplorer")
#define CLanguage_Move                          _T("Move")
#define CLanguage_Close                         _T("Close")
#define CLanguage_Merged                        _T("Merged")
#define CLanguage_MergeToSpecificFolder         _T("MergeToSpecificFolder")
#define CLanguage_EmptyMergedFolderName         _T("EmptyMergedFolderName")

class CLanguage:public IIniFileArrayItem
{
public:
    CLanguage(void);
    ~CLanguage(void);

    TCHAR FolderNotFound    [CLanguage_MediumNameSize];
    TCHAR Show              [CLanguage_ShortNameSize];
    TCHAR Options           [CLanguage_ShortNameSize];
    TCHAR Help              [CLanguage_ShortNameSize];
    TCHAR About             [CLanguage_ShortNameSize];
    TCHAR MakeADonation     [CLanguage_ShortNameSize];
    TCHAR Exit              [CLanguage_ShortNameSize];
    TCHAR CheckForUpdate    [CLanguage_ShortNameSize];
    TCHAR Add               [CLanguage_ShortNameSize];
    TCHAR Remove            [CLanguage_ShortNameSize];
    TCHAR Folders           [CLanguage_ShortNameSize];
    TCHAR Horizontal        [CLanguage_ShortNameSize];
    TCHAR Vertical          [CLanguage_ShortNameSize];
    TCHAR Diagonal          [CLanguage_ShortNameSize];
    TCHAR BackwardDiagonal  [CLanguage_ShortNameSize];
    TCHAR Stretched    [CLanguage_ShortNameSize];
    TCHAR Centered     [CLanguage_ShortNameSize];
    TCHAR UpLeft       [CLanguage_ShortNameSize];
    TCHAR UpCenter     [CLanguage_ShortNameSize];
    TCHAR UpRight      [CLanguage_ShortNameSize];
    TCHAR Left         [CLanguage_ShortNameSize];
    TCHAR Right        [CLanguage_ShortNameSize];
    TCHAR BottomLeft   [CLanguage_ShortNameSize];
    TCHAR BottomCenter [CLanguage_ShortNameSize];
    TCHAR BottomRight  [CLanguage_ShortNameSize];
    TCHAR Icons        [CLanguage_ShortNameSize];
    TCHAR SmallIcons   [CLanguage_ShortNameSize];
    TCHAR List         [CLanguage_ShortNameSize];
    TCHAR Detail       [CLanguage_ShortNameSize];
    TCHAR Thumbnails   [CLanguage_ShortNameSize];
    TCHAR Tiles        [CLanguage_ShortNameSize];
    TCHAR ThumbStrip   [CLanguage_ShortNameSize];
    TCHAR Type         [CLanguage_ShortNameSize];
    TCHAR SystemSpecialPath     [CLanguage_ShortNameSize];
    TCHAR LocalOrRelativePath   [CLanguage_ShortNameSize];
    TCHAR UnsupportedImageFormat[CLanguage_ShortNameSize];
    TCHAR BrowsingOptions       [CLanguage_ShortNameSize];
    TCHAR FileFilters           [CLanguage_ShortNameSize];
    TCHAR Customization         [CLanguage_ShortNameSize];
    TCHAR MoveUp                [CLanguage_ShortNameSize];
    TCHAR MoveDown              [CLanguage_ShortNameSize];
    TCHAR NoFolderSelected      [CLanguage_ShortNameSize];
    TCHAR Error                 [CLanguage_ShortNameSize];
    TCHAR ForMoreInformations   [CLanguage_ShortNameSize];
    TCHAR See                   [CLanguage_ShortNameSize];
    TCHAR ProjectHomePage       [CLanguage_ShortNameSize];
    TCHAR Or                    [CLanguage_ShortNameSize];
    TCHAR UserManual            [CLanguage_ShortNameSize];
    TCHAR Author                [CLanguage_ShortNameSize];
    TCHAR ShortcutType          [CLanguage_ShortNameSize];
    TCHAR Desktop               [CLanguage_ShortNameSize];
    TCHAR Browser               [CLanguage_ShortNameSize];
    TCHAR Menu                  [CLanguage_ShortNameSize];
    TCHAR MultipleFoldersMenu   [CLanguage_ShortNameSize];
    TCHAR AssociatedIcon        [CLanguage_ShortNameSize];
    TCHAR Ok                    [CLanguage_ShortNameSize];
    TCHAR Cancel                [CLanguage_ShortNameSize];
    TCHAR Background            [CLanguage_ShortNameSize];
    TCHAR None                  [CLanguage_ShortNameSize];
    TCHAR Color                 [CLanguage_ShortNameSize];
    TCHAR Gradiant              [CLanguage_ShortNameSize];
    TCHAR Picture               [CLanguage_ShortNameSize];
    TCHAR Color1                [CLanguage_ShortNameSize];
    TCHAR Color2                [CLanguage_ShortNameSize];
    TCHAR ApplicationOptions    [CLanguage_ShortNameSize];
    TCHAR ConfigurationType     [CLanguage_ShortNameSize];
    TCHAR SingleUser            [CLanguage_ShortNameSize];
    TCHAR MultipleUsers         [CLanguage_ShortNameSize];
    TCHAR LaunchAtWindowsStartup[CLanguage_MediumNameSize];
    TCHAR LaunchMode            [CLanguage_ShortNameSize];
    TCHAR NotifyIcon            [CLanguage_ShortNameSize];
    TCHAR LaunchBar             [CLanguage_ShortNameSize];
    TCHAR IncludeSubfolders     [CLanguage_MediumNameSize];
    TCHAR AllowSubfoldersNavigation[CLanguage_LargeNameSize];
    TCHAR AllowSubfoldersLinksNavigation[CLanguage_LargeNameSize];
    TCHAR HideFilesExtensions   [CLanguage_MediumNameSize];
    TCHAR HideShortcutsOverlay  [CLanguage_LargeNameSize];
    TCHAR RememberLastPosition  [CLanguage_MediumNameSize];
    TCHAR SingleClickSelection  [CLanguage_MediumNameSize];
    TCHAR AutoHideOnExecution   [CLanguage_MediumNameSize];
    TCHAR ViewType              [CLanguage_ShortNameSize];
    TCHAR TextColor             [CLanguage_ShortNameSize];
    TCHAR BackgroundColor       [CLanguage_ShortNameSize];
    TCHAR ExclusionFilters      [CLanguage_ShortNameSize];
    TCHAR InclusionFilters      [CLanguage_ShortNameSize];
    TCHAR Language              [CLanguage_ShortNameSize];
    TCHAR Skin                  [CLanguage_ShortNameSize];
    TCHAR Path                  [CLanguage_ShortNameSize];
    TCHAR Position              [CLanguage_ShortNameSize];
    TCHAR ZOrder                [CLanguage_ShortNameSize];
    TCHAR Normal                [CLanguage_ShortNameSize];
    TCHAR TopMost               [CLanguage_ShortNameSize];
    TCHAR ZBottom               [CLanguage_ShortNameSize];
    TCHAR Bottom                [CLanguage_ShortNameSize];
    TCHAR HideToolBarForHomeFolder [CLanguage_MediumNameSize];
    TCHAR HideToolBar           [CLanguage_MediumNameSize];
    TCHAR Hide                  [CLanguage_ShortNameSize];
    TCHAR Maximize              [CLanguage_ShortNameSize];
    TCHAR Reduce                [CLanguage_ShortNameSize];
    TCHAR SaveIconsPositionsForHomeFolder[CLanguage_MediumNameSize];
    TCHAR ShowAtStartup         [CLanguage_MediumNameSize];
    TCHAR StartMaximized        [CLanguage_MediumNameSize];
    TCHAR Medium                [CLanguage_ShortNameSize];
    TCHAR Large                 [CLanguage_ShortNameSize];
    TCHAR ExtraLarge            [CLanguage_ShortNameSize];
    TCHAR ShowHideHotKey        [CLanguage_MediumNameSize];
    TCHAR Name                  [CLanguage_ShortNameSize];
    TCHAR LaunchBarSpecific     [CLanguage_MediumNameSize];
    TCHAR OverIcon              [CLanguage_ShortNameSize];
    TCHAR PressedIcon           [CLanguage_ShortNameSize];
    TCHAR Monitor               [CLanguage_ShortNameSize];
    TCHAR Direction             [CLanguage_ShortNameSize];
    TCHAR UseFullWidthHeight    [CLanguage_MediumNameSize];
    TCHAR IconsSize             [CLanguage_ShortNameSize];
    TCHAR UseTransparentColor   [CLanguage_MediumNameSize];
    TCHAR Opacity               [CLanguage_ShortNameSize];
    TCHAR ActiveAreaThickness   [CLanguage_MediumNameSize];
    TCHAR MinWidth              [CLanguage_ShortNameSize];
    TCHAR MinHeight             [CLanguage_ShortNameSize];
    TCHAR Margins               [CLanguage_ShortNameSize];
    TCHAR Top                   [CLanguage_ShortNameSize];
    TCHAR EnableHotCorner       [CLanguage_MediumNameSize];
    TCHAR HotCorner             [CLanguage_ShortNameSize];
    TCHAR Width                 [CLanguage_ShortNameSize];
    TCHAR Height                [CLanguage_ShortNameSize];
    TCHAR LeftOrTop             [CLanguage_MediumNameSize];
    TCHAR CenterOrMiddle        [CLanguage_MediumNameSize];
    TCHAR RightOrBottom         [CLanguage_MediumNameSize];
    TCHAR SpaceBeforeIcon       [CLanguage_MediumNameSize];
    TCHAR MergeMenus            [CLanguage_MediumNameSize];
    TCHAR FoldersPositionInPopupMenu [CLanguage_MediumNameSize];
    TCHAR MixedWithFiles        [CLanguage_MediumNameSize];
    TCHAR GoToHomeFolder        [CLanguage_MediumNameSize];
    TCHAR GoBack                [CLanguage_MediumNameSize];
    TCHAR GoForward             [CLanguage_MediumNameSize];
    TCHAR GoUp                  [CLanguage_MediumNameSize];
    TCHAR OpenFolderWithWindowsExplorer [CLanguage_MediumNameSize];
    TCHAR Move                  [CLanguage_ShortNameSize];
    TCHAR Close                 [CLanguage_ShortNameSize];
    TCHAR Merged                [CLanguage_ShortNameSize];
    TCHAR MergeToSpecificFolder [CLanguage_MediumNameSize];
    TCHAR EmptyMergedFolderName [CLanguage_MediumNameSize];

    virtual BOOL Save(CIniFile* pIniFile);
    virtual BOOL Load(CIniFile* pIniFile);

    void Clone(IN OUT CLanguage* pLanguage);
};
