/*
Copyright (C) 2014 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2014 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: Manage QuickWayToFolder Launch bar
//-----------------------------------------------------------------------------

#pragma once

#include <Windows.h>
#include <vector>

#include "../Tools/GUI/TransparentToolbar/TransparentToolbar.h"
#include "../Tools/GUI/HotWindow/HotWindow.h"

#include "LaunchBarOptions.h"
#include "ContainerBase.h"
class CQuickWayToFolders;

//pseudo container used only to manage right click on toolbar background
class CLaunchBarContainerBase : public CContainerBase
{
public:
    CLaunchBarContainerBase(HINSTANCE hInstance,CQuickWayToFolders* pQuickWayToFolders):CContainerBase(hInstance,pQuickWayToFolders)
    {

    }

    virtual BOOL UpdateOptionsBeforeClose(){return TRUE;}
    virtual BOOL SetLanguage(CLanguage* pLanguage)
    {
        return this->InternalSetLanguage(pLanguage,FALSE);
    }
};

class CLaunchBar: public CTransparentToolbarEventsBase, public CHotWindowEventsBase
{
protected:
    CHotWindow* pHotWindow;
    CTransparentToolbar* pTransparentToolBar;
    std::vector<CTransparentToolbar::BUTTON_DESCRIPTION> ButtonsList;
    CLaunchBarOptions::tagPosition Position;

    virtual void OnTransparentToolbarBackgroundRightClick(CTransparentToolbar* pSender,POINT* pCursorPos);
    virtual void OnTransparentToolbarButtonClick(CTransparentToolbar* pSender,DWORD ButtonId);
    virtual void OnTransparentToolbarButtonRightClick(CTransparentToolbar* pSender,DWORD ButtonId);
    virtual void OnHotWindowAutoShow(CHotWindow* pSender,OUT BOOL* pUseAutoHideDisabledExtraRect,OUT RECT* pAutoHideDisabledExtraRect);
    virtual void OnHotWindowAutoHide(CHotWindow* pSender);
public:
    CLaunchBarContainerBase* pLaunchBarContainerBase;
    CLaunchBar(void);
    virtual ~CLaunchBar(void);
    HWND GetControlHandle();
    BOOL Create(CQuickWayToFolders* pQuickWayToFolders,HINSTANCE hInstance,CLaunchBarOptions* pOptions);
    void Destroy();
    BOOL Show();
    BOOL Hide();
    BOOL AddButton(CTransparentToolbar::BUTTON_DESCRIPTION* pButton);
    void RemoveAllButtons();
    SIZE_T GetButtonsCount();
};

