/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#ifndef _WIN32_WINNT
    #define _WIN32_WINNT 0x0501
#endif

#include <windows.h>

#include <gdiplus.h>
#pragma comment (lib,"gdiplus.lib")

#include "../Tools/Ini/IniFileEx.h"
#include "../Tools/gui/ShellBrowser/ShellBrowserEx.h"
#include "../Tools/GUI/TransparentToolbar/TransparentToolbar.h"
#include "../Tools/GUI/FolderMenu/FolderMenu.h"
#include "Language.h"

#define CSingleFolderOptions_CSIDL_PREFIX     _T("::CSIDL:")
#define CSingleFolderOptions_FILTERS_MAX_SIZE 1024


#define CSingleFolderOptions_KEY_FOLDERPRESENTATIONTYPE _T("FolderPresentationType")
#define CSingleFolderOptions_KEY_PATH                   _T("Path")
#define CSingleFolderOptions_KEY_DISPLAY_NAME           _T("DisplayName")
#define CSingleFolderOptions_KEY_ASSOCIATEDICONPATH     _T("AssociatedIconPath")
#define CSingleFolderOptions_KEY_ASSOCIATEDICONINDEX    _T("AssociatedIconIndex")
#define CSingleFolderOptions_KEY_ASSOCIATEDHOTICONPATH  _T("AssociatedHotIconPath")
#define CSingleFolderOptions_KEY_ASSOCIATEDHOTICONINDEX _T("AssociatedHotIconIndex")
#define CSingleFolderOptions_KEY_ASSOCIATEDDOWNICONPATH _T("AssociatedDownIconPath")
#define CSingleFolderOptions_KEY_ASSOCIATEDDOWNICONINDEX _T("AssociatedDownIconIndex")
#define CSingleFolderOptions_KEY_ASSOCIATEDICONPOSITION  _T("AssociatedIconPosition")
#define CSingleFolderOptions_KEY_INCLUDESUBFOLDERS      _T("IncludeSubFolders")
#define CSingleFolderOptions_KEY_ALLOWSUBFOLDERSNAVIGATION _T("AllowSubFoldersNavigation")
#define CSingleFolderOptions_KEY_ALLOWSUBFOLDERSLINKSNAVIGATION _T("AllowSubFoldersLinksNavigation")
#define CSingleFolderOptions_KEY_INCLUSIONFILTERS       _T("InclusionFilters")
#define CSingleFolderOptions_KEY_EXCLUSIONFILTERS       _T("ExclusionFilters")
#define CSingleFolderOptions_KEY_HIDE_FILES_EXTENSION_IN_POPUPMENU _T("HideFilesExtensionInPopupMenu")
#define CSingleFolderOptions_KEY_HIDE_SHORTCUTS_OVERLAY_IN_POPUPMENU _T("HideShortcutsOverlayInPopupMenu")
#define CSingleFolderOptions_KEY_FOLDER_POSITION_IN_POPUPMENU _T("FoldersPositionInPopupMenu")
#define CSingleFolderOptions_KEY_MERGE_MENUS_IN_POPUPMENU _T("MergeMenusInPopupMenu")
#define CSingleFolderOptions_KEY_FOLDERVIEWMODE         _T("FolderViewMode")
#define CSingleFolderOptions_KEY_REMEMBERLASTPOSITION   _T("RememberLastPosition")
#define CSingleFolderOptions_KEY_ONECLICKACTIVATE       _T("OneClickActivate")
#define CSingleFolderOptions_KEY_AUTOHIDEONFILEEXECUTION _T("AutoHideOnFileExecution")
#define CSingleFolderOptions_KEY_ISMAXIMIZED            _T("IsMaximized")
#define CSingleFolderOptions_KEY_BROWSERWIDTH           _T("BrowserWidth")
#define CSingleFolderOptions_KEY_BROWSERHEIGHT          _T("BrowserHeight")
#define CSingleFolderOptions_KEY_WINDOWPOSITIONX        _T("WindowPositionX")
#define CSingleFolderOptions_KEY_WINDOWPOSITIONY        _T("WindowPositionY")
#define CSingleFolderOptions_KEY_TEXTCOLORSEPCIFIED     _T("TextColorSepcified")
#define CSingleFolderOptions_KEY_TEXTCOLOR              _T("TextColor")
#define CSingleFolderOptions_KEY_TEXTBACKGROUNDCOLORSEPCIFIED _T("TextBackgroundColorSepcified")
#define CSingleFolderOptions_KEY_TEXTBACKGROUNDCOLOR    _T("TextBackgroundColor")
#define CSingleFolderOptions_KEY_BACKGROUNDTYPE         _T("BackgroundType")
#define CSingleFolderOptions_KEY_BACKGROUNDCOLOR        _T("BackgroundColor")
#define CSingleFolderOptions_KEY_BACKGROUNDCOLOR1       _T("BackgroundColor1")
#define CSingleFolderOptions_KEY_BACKGROUNDCOLOR2       _T("BackgroundColor2")
#define CSingleFolderOptions_KEY_BACKGROUNDGRADIANTTYPE _T("BackgroundGradiantType")
#define CSingleFolderOptions_KEY_BACKGROUNDIMAGEPATH    _T("BackgroundImagePath")
#define CSingleFolderOptions_KEY_BACKGROUNDIMAGEPOSITION _T("BackgroundImagePosition")
#define CSingleFolderOptions_KEY_MULTIPLE_DIRECTORIES_NUMBER _T("MultipleDirectoriesNumber")
#define CSingleFolderOptions_KEY_MULTIPLE_DIRECTORIES_DIR_PREFIX _T("Directory_")
#define CSingleFolderOptions_KEY_MULTIPLE_DIRECTORIES_MERGE_TO_SPECIFIC_FOLDER_PREFIX _T("MergedMenu_")
#define CSingleFolderOptions_KEY_MULTIPLE_DIRECTORIES_MERGED_FOLDER_NAME_PREFIX _T("MergedMenuName_")
#define CSingleFolderOptions_KEY_Z_ORDER                _T("ZOrder")
#define CSingleFolderOptions_KEY_HIDE_TOOLBAR           _T("HideToolBar")
#define CSingleFolderOptions_KEY_HIDE_TOOLBAR_FOR_HOME_FOLDER _T("HideToolBarForHomeFolder")
#define CSingleFolderOptions_KEY_SAVE_ICONS_POSITIONS_FOR_HOME_FOLDER _T("SaveIconsPositionsForHomeFolder")
#define CSingleFolderOptions_KEY_NB_ICONS_IN_HOME_FOLDER        _T("NbIconsInHomeFolder")
#define CSingleFolderOptions_KEY_HOME_FOLDER_ITEM_NAME          _T("HomeFolderItemName")
#define CSingleFolderOptions_KEY_HOME_FOLDER_ITEM_X_POSITION    _T("HomeFolderItemPosX")
#define CSingleFolderOptions_KEY_HOME_FOLDER_ITEM_Y_POSITION    _T("HomeFolderItemPosY")
#define CSingleFolderOptions_KEY_SHOW_AT_STARTUP                _T("ShowAtStartup")
#define CSingleFolderOptions_KEY_START_MAXIMIZED                _T("StartMaximized")
#define CSingleFolderOptions_HOTKEY_MODIFIER                    _T("HotKeyModifier")
#define CSingleFolderOptions_HOTKEY_VIRTUALKEY                  _T("HotKeyVirtualKey")
#define CSingleFolderOptions_ENABLEHOTCORNER            _T("EnableHotCorner")
#define CSingleFolderOptions_HOTCORNERSCREENINDEX       _T("HotCornerScreenIndex")
#define CSingleFolderOptions_HOTCORNERPOSITION          _T("HotCornerPosition")
#define CSingleFolderOptions_HOTCORNERWIDTH             _T("HotCornerWidth")
#define CSingleFolderOptions_HOTCORNERHEIGHT            _T("HotCornerHeight")
#define CSingleFolderOptions_LAUNCHBARSPACERBEFOREICONINPIXELS _T("LaunchBarFreeSpaceBeforeIcon")
#define CSingleFolderOptions_MAX_NAME_SIZE              2048

class CSingleFolderOptions:public IIniFileArrayItem
{
public:
    CSingleFolderOptions(void);
    ~CSingleFolderOptions(void);

    virtual BOOL Save(CIniFile* pIniFile);
    virtual BOOL Load(CIniFile* pIniFile);
    BOOL IsCSIDL();
    static BOOL IsCSIDL(TCHAR* CLSIDorPath);
    BOOL GetPath(OUT TCHAR* Path,IN SIZE_T PathMaxSize);
    static BOOL GetPath(TCHAR* CLSIDorPath,OUT TCHAR* Path,IN SIZE_T PathMaxSize);
    static BOOL GetChildDirName(TCHAR* CSIDLorPath,OUT TCHAR* ChildDir);
    static BOOL GetCSIDL(TCHAR* CSIDLorPath,OUT DWORD* pCSIDL);
    BOOL GetShortName(IN OUT TCHAR* QuickName);// QuickName must be at least MAX_PATH len



    typedef struct tagVectorIconsPositionsForHomeFolder
    {
        TCHAR Name[CSingleFolderOptions_MAX_NAME_SIZE]; // should be the same as CDesktopBrowser_MAX_PATH
        POINT Position;
    }VECTOR_ICONS_POSITIONS_FOR_HOME_FOLDER,*PVECTOR_ICONS_POSITIONS_FOR_HOME_FOLDER;

    enum tagFolderPresentationType
    {
        FOLDER_PRESENTATION_TYPE_BROWSER=0,
        FOLDER_PRESENTATION_TYPE_DESKTOP_BROWSER=1,
        FOLDER_PRESENTATION_TYPE_SINGLE_MENU=2,
        FOLDER_PRESENTATION_TYPE_MULTIPLE_MENU=3
    };
    enum tagBrowserZOrder
    {
        BROWSER_Z_ORDER_NORMAL=0,
        BROWSER_Z_ORDER_TOP_MOST=1,
        BROWSER_Z_ORDER_BOTTOM=2
    };

    tagFolderPresentationType FolderPresentationType;
    TCHAR DisplayName[256];// currently used only for multiple folder menu
    TCHAR Path[MAX_PATH];
    TCHAR AssociatedIconPath[MAX_PATH];
    DWORD AssociatedIconIndex;
    BOOL bIncludeSubFolders;
    BOOL bAllowSubFoldersNavigation;
    BOOL bAllowSubFoldersLinksNavigation;
    TCHAR InclusionFilters[CSingleFolderOptions_FILTERS_MAX_SIZE];
    TCHAR ExclusionFilters[CSingleFolderOptions_FILTERS_MAX_SIZE];

    // specific to browser / desktop browser
    CShellBrowserEx::tagShellBrowserView FolderViewMode;
    BOOL bRememberLastPosition;
    BOOL bOneClickActivate;
    RECT BrowserRect;// shell def view rect in client coordinates
    POINT WindowPosition;// window container x,y position (left,top corner)
    BOOL bIsMaximized;
    BOOL bAutoHideOnFileExecution;
    tagBrowserZOrder ZOrder;
    BOOL bHideToolBarForHomeFolder;
    BOOL bHideToolBar;
    BOOL bShowAtStartup;
    BOOL bStartMaximized;
    // specific to browser
    BOOL bSaveIconsPositionsForHomeFolder;
    std::vector<VECTOR_ICONS_POSITIONS_FOR_HOME_FOLDER>* pIconsPositionsForHomeFolder;

    // specific to browser / desktop browser background / text style 
    BOOL bTextColorSepcified;
    COLORREF TextColor;
    BOOL bTextBackgroundColorSepcified;
    COLORREF TextBackgroundColor;
    CShellBrowserEx::tagBackgroundType BackgroundType;
    COLORREF BackgroundColor;
    COLORREF BackgroundColor1;
    COLORREF BackgroundColor2;
    Gdiplus::LinearGradientMode BackgroundGradiantType;
    TCHAR BackgroundImagePath[MAX_PATH];
    CShellBrowserEx::tagBackgroundImagePosition BackgroundImagePosition;


    DWORD HotKeyfsModifiers;
    DWORD HotKeyVirtualKey;

    // specific to multiple paths menu 
    std::vector<CFolderMenu::MULTIPLE_PATHS_DATA>* pMultiplePaths;

    // specific to menu
    BOOL bHideFilesExtensionInPopupMenu;
    BOOL bHideShortcutsOverlayInPopupMenu;
    CFolderMenu::tagFoldersPosition FoldersPositionInPopUpMenu;
    BOOL bMergeMenusInPopUpMenu;

    enum tagHotCornerPosition
    {
        HOT_CORNER_POSITION_TOP_LEFT=0,
        HOT_CORNER_POSITION_TOP_RIGHT,
        HOT_CORNER_POSITION_BOTTOM_LEFT,
        HOT_CORNER_POSITION_BOTTOM_RIGHT
    };
    BOOL bEnableHotCorner;
    DWORD HotCornerScreenIndex;
    tagHotCornerPosition HotCornerPosition; // top left, top right, bottom left, bottom right
    DWORD HotCornerWidth;
    DWORD HotCornerHeight;

    DWORD LaunchBarFreeSpaceBeforeIcon;
// #pragma message ("LineBreakBeforeIcon to be implemented") : commented to avoid multiple messages in each cpp including .h
    // BOOL  LaunchBarLineBreakBeforeIcon;
    TCHAR LaunchBarAssociatedIconHotPath[MAX_PATH];
    DWORD LaunchBarAssociatedIconHotIndex;
    TCHAR LaunchBarAssociatedIconDownPath[MAX_PATH];
    DWORD LaunchBarAssociatedIconDownIndex;
    CTransparentToolbar::tagButtonPosition LaunchBarIconPosition;
};
