/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501 // for xp os
#endif

#ifndef _WIN32_IE
#define _WIN32_IE 0x0500 // should be at least ie 5
#endif

// Enable Visual Style
#if defined _AMD64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _WIN64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#else
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif


#include <Windows.h>
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)

#include "..\Tools\Exception\HardwareException.h"
#include "..\Tools\CrashDump\CrashDump.h"
#include "QuickWayToFolders.h"

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow
                   )
{
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);
    UNREFERENCED_PARAMETER(nCmdShow);

#ifndef _WIN64
	SYSTEM_INFO SystemInfo={0};
    ::GetNativeSystemInfo(&SystemInfo);
    switch(SystemInfo.wProcessorArchitecture)
    {
        case PROCESSOR_ARCHITECTURE_AMD64:    // 9    x64 (AMD or Intel)
			// as we need to send messages to explorer process, structs of messages sent MUST BE of the same size as the explorer process
			// ans as size of structs are different in 32 and 64 bits process we have to put limitation
			::MessageBox(NULL,
						_T("Version not compatible with 64 bit operating system !\r\n")
						_T("You have to download 64 bit version at http://jacquelin.potier.free.fr"),
						_T("Error"),
						MB_ICONERROR | MB_OK | MB_SYSTEMMODAL
						);
			return -1;
	}
#endif

#ifndef _DEBUG
    try
    {
        CExceptionHardware::RegisterTry();
#endif

        CQuickWayToFolders QuickWayToFolders;
        QuickWayToFolders.Start(hInstance);

#ifndef _DEBUG
    }
    catch( CExceptionHardware e ) // catch hardware exceptions
    {
        // dynamically load MessageBox function (avoid static linking)
        HMODULE hModule = ::GetModuleHandle(_T("user32.dll"));
        if (!hModule)
        {
            hModule = ::LoadLibrary(_T("user32.dll"));
            if (!hModule)
                return FALSE;
        }

        typedef int (WINAPI *pfMessageBoxW)(HWND hWnd,LPCWSTR lpText,LPCWSTR lpCaption,UINT uType);
        pfMessageBoxW pMessageBoxW = (pfMessageBoxW)::GetProcAddress(hModule,"MessageBoxW");
        if (pMessageBoxW)
        {
            if (
                pMessageBoxW(NULL,
                L"An exception has occurred.\r\nDo you want to save a crash dump file to report error to author ?",
                L"Exception",
                MB_ICONQUESTION | MB_YESNO | MB_SYSTEMMODAL
                )
                == IDYES
                )
            {
                CCrashDump::GenerateCrashDump(MiniDumpNormal,e.pExceptionInformation);
            }

            if (
                pMessageBoxW(NULL,
                            L"Restart application ?",
                            L"Query",
                            MB_ICONQUESTION | MB_YESNO | MB_SYSTEMMODAL
                            )
                == IDYES
                )
            {
                // create a new process to avoid remaining current global vars
                PROCESS_INFORMATION pi={0};
                STARTUPINFO si={0};
                ::CreateProcess(0,::GetCommandLine(),0,0,0,0,0,0,&si,&pi);
                CloseHandle( pi.hProcess );
                CloseHandle( pi.hThread );                
            }
        }
    }
    
#endif    
   
	return 0;
}



