/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: class to quickly check file names according to a filter list
//-----------------------------------------------------------------------------

#pragma once

#include "../String/WildCharCompare.h"
#include <vector>

#define CFilesFilters_SPLITTER _T(";")// splitter
class CFilesFilters
{
public:
    enum tagFilterType
    {
        FILTER_TYPE_INCLUSION,
        FILTER_TYPE_EXCLUSION
    };
    CFilesFilters(tagFilterType FiltersType,TCHAR* Filters);
    ~CFilesFilters(void);

    BOOL Check(TCHAR* FileName);

private:
    tagFilterType FiltersType;
    TCHAR* Filters;
    std::vector<TCHAR*> FiltersList;
};
