/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: class helper for windows start menu
//-----------------------------------------------------------------------------

#include "StartMenu.h"

//-----------------------------------------------------------------------------
// Name: IsClassicStartMenu
// Object: test if windows start menu is classic start menu
// Parameters :
//     in  : 
//     out :
//     return : TRUE if windows start menu is classic start menu
//-----------------------------------------------------------------------------
BOOL CStartMenu::IsClassicStartMenu()
{
    SHELLSTATE ShellState={0};

    // Notice : information can be retrieved through HKCU\Software\Microsoft\Windows\Current Version\Explorer\ShellState too
    ::SHGetSetSettings(&ShellState,SSF_STARTPANELON,FALSE);

    // ShellState.fStartPanelOn == 0 : Classical Start Menu
    // ShellState.fStartPanelOn == 2 : Xp Start Menu
    return (ShellState.fStartPanelOn == 0); 
}