/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#include <windows.h>

class CShellExecuteAndBringToTop
{
protected:
    typedef struct tagCallBackParam
    {
        DWORD ProcessId;
        BOOL bSuccess;
    };
    static BOOL __stdcall SetWindowToTopFromhProcess(HWND hwnd, LPARAM lParam);

public:
    // MSDN
    // Because ShellExecuteEx can delegate execution to Shell extensions (data sources, context menu handlers, verb implementations) 
    // that are activated using Component Object Model (COM), COM should be initialized before ShellExecuteEx is called. 
    // Some Shell extensions require the COM single-threaded apartment (STA) type. 
    // In that case, COM should be initialized as shown here: CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE)
    // There are instances where ShellExecuteEx does not use one of these types of Shell extension 
    // and those instances would not require COM to be initialized at all. 
    // Nonetheless, it is good practice to always initialize COM before using this function.
    static BOOL ShellExecuteAndBringToTop(SHELLEXECUTEINFO* pExecuteInfo);

    static HINSTANCE ShellExecute(HWND hwnd,LPCTSTR lpOperation,LPCTSTR lpFile,LPCTSTR lpParameters,LPCTSTR lpDirectory,INT nShowCmd);


};

