/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "OsVersion.h"


COsVersion::pfRtlGetVersion COsVersion::pRtlGetVersion = NULL;
BOOL COsVersion::pRtlGetVersionLoadTried = FALSE;

COsVersion::COsVersion(void)
{
    memset(&this->VersionInfos,0,sizeof(this->VersionInfos));
    this->VersionInfos.dwOSVersionInfoSize = sizeof(this->VersionInfos);

    if (COsVersion::pRtlGetVersionLoadTried == FALSE)
    {
        // GetVersionExW start sucking with win 8.1, but RtlGetVersion still provide correct value...
        // M$ mystery... or kernel devs are more clever :)
        HMODULE hModule = ::GetModuleHandle(TEXT("ntdll.dll"));
        COsVersion::pRtlGetVersion = (pfRtlGetVersion)::GetProcAddress(hModule,"RtlGetVersion");
        COsVersion::pRtlGetVersionLoadTried = TRUE;
    }

    if (COsVersion::pRtlGetVersion)
        COsVersion::pRtlGetVersion((OSVERSIONINFOW*)&this->VersionInfos);
    else
    {
        ::GetVersionExW((OSVERSIONINFOW*)&this->VersionInfos);
    }
}

COsVersion::~COsVersion(void)
{
}
