/*
Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2015 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once

#include <Windows.h>


// Windows 7 6.1 
// Windows Server 2008 R2 6.1 
// Windows Server 2008 6.0 
// Windows Vista 6.0 
// Windows Server 2003 R2 5.2 
// Windows Server 2003 5.2 
// Windows XP 5.1 
// Windows 2000 5.0 
class COsVersion
{
protected:
    typedef NTSTATUS (NTAPI *pfRtlGetVersion)(OSVERSIONINFOW* lpVersionInformation);
    static pfRtlGetVersion pRtlGetVersion;
    static BOOL pRtlGetVersionLoadTried;
public:
    OSVERSIONINFOEXW VersionInfos;
    BOOL IsXpSp2OrNewer()
    {
        // if os is newer than xp
        if ((this->VersionInfos.dwMajorVersion>5) || ( (this->VersionInfos.dwMajorVersion==5) && (this->VersionInfos.dwMinorVersion>1) ))
            return TRUE;
        // if Os is XP and service pack is upper or equal to 2
        if ( (this->VersionInfos.dwMajorVersion==5) && (this->VersionInfos.dwMinorVersion==1) && (this->VersionInfos.wServicePackMajor>=2))
            return TRUE;
        // else (older)
        return FALSE;
    }
    BOOL IsXpOrNewer(){return ( (this->VersionInfos.dwMajorVersion>5) || ( (this->VersionInfos.dwMajorVersion==5) && (this->VersionInfos.dwMinorVersion>=1) ) );}
    BOOL IsVistaOrNewer(){return (this->VersionInfos.dwMajorVersion>=6);}
    BOOL IsSevenOrNewer(){return ( (this->VersionInfos.dwMajorVersion>6) || ( (this->VersionInfos.dwMajorVersion==6) && (this->VersionInfos.dwMinorVersion>=1) ) );}
    BOOL IsWin8OrNewer(){return ( (this->VersionInfos.dwMajorVersion>6) || ( (this->VersionInfos.dwMajorVersion==6) && (this->VersionInfos.dwMinorVersion>=2) ) );}
    BOOL IsWin10OrNewer(){return (this->VersionInfos.dwMajorVersion>=10);}
    BOOL IsWin11OrNewer(){return ( (this->VersionInfos.dwMajorVersion>10) || ( (this->VersionInfos.dwMajorVersion==10) && (this->VersionInfos.dwMinorVersion>=22000) ) );}

    BOOL IsXp(){return ( (this->VersionInfos.dwMajorVersion==5) && (this->VersionInfos.dwMinorVersion==1) );}
    BOOL IsVista(){return ( (this->VersionInfos.dwMajorVersion==6)  && (this->VersionInfos.dwMinorVersion==0) ) ;}
    BOOL IsSeven(){return ( (this->VersionInfos.dwMajorVersion==6)  && (this->VersionInfos.dwMinorVersion==1) ) ;}
    BOOL IsWin8(){return ( (this->VersionInfos.dwMajorVersion==6)  && (this->VersionInfos.dwMinorVersion==2) ) ;}
    BOOL IsWin8_1(){return ( (this->VersionInfos.dwMajorVersion==6)  && (this->VersionInfos.dwMinorVersion==3) ) ;}

    COsVersion(void);
    ~COsVersion(void);
};

